#!/usr/bin/perl
##############################################################################
# news.cgi                                                                   #
# [MV]DarkViper's News Script (created: 16.04.2000)                          #
#                                                                            #
# [MV]DarkViper                                                              #
# eMail   : webmaster@mvclan.de                                              #
# Homepage: www.mvclan.de                                                    #
# __________________________________________________________________________ #
# Copyright (C) by [MV]DarkViper (Thomas Pajor), 2000                        #
# Alle Rechte vorbehalten.                                                   #
#                                                                            #
##############################################################################
########################################### EINGEBUNDENE LIBRARIES ###########
use vars qw($req);
use CGI  qw(:cgi);
$req = new CGI;
#print "Content-type: text/html\n\n"; # HTML Ausgabe aktivieren
##############################################################################
#
# Variablen :)
#
##############################################################################
$script_version = '3.0';
$file_cnt = 'news.cnt';
$file_db = 'news.dat';
$file_fdb = 'news.fdb';
$file_cfg = 'news.cfg';
$file_reg = 'news.reg';
$gl_sep = '///-_sep_-///';
$gl_sep_2 = '///__sep__///';
$gl_sep_3 = '///--sep--///';
$gl_none = 'none';
$gl_null = '0';

getconfig();
@hash_month = ('Januar', 'Februar', 'M&auml;rz', 'April', 'Mai', 'Juni', 'Juli', 'August',
               'September', 'Oktober', 'November', 'Dezember');
               
$html_nav = <<EOF;
$html_body
 <h1>News %title%</h1>
 <p align="center"><b>
   [ <a href="$url_script?action=view">News Anzeigen</a> ] &#149; 
   [ <a href="$url_script?action=add&login=%login%&passwd=%passwd%">News Hinzuf&uuml;gen</a> ] &#149; 
   [ <a href="$url_script?action=admin&login=%login%&passwd=%passwd%">News Verwalten</a> ]</b><br><font size="1">
   [ <a href="$url_script?action=delbytimeform&login=%login%&passwd=%passwd%">L&ouml;schen nach Zeit</a> ] &#149;
   [ <a href="$url_script?action=adminprofiles&login=%login%&passwd=%passwd%">Feedback Profile Verwalten</a> ] &#149;
   [ <a href="pwd.cgi" target="_blank">Benutzer</a> ]</font>
 </p><br>  
EOF

# Navigation im Feedback bereich
$html_fdb_nav = <<EOF;
 <p align="center">
  <b>[ <a href="$url_script?action=view">Zur&uuml;ck</a> ] &#149; [ <a href="$url_script?action=addfeedback&num=%num%">Beitrag Hinzuf&uuml;gen</a> ]</b><br>
  <font size="1">[ <a href="$url_script?action=addprofile">Registrieren</a> ] &#149; [ <a href="$url_script?action=editprofile">Profil Editieren</a> ] &#149; [ <a href="$url_script?action=getpasswd">Passwort?</a> ]</font>
 </p>
EOF

$html_copyright = <<EOF;
<p align="center"><font size="1" face="Verdana">
Copyright  2000 by <a href="mailto:webmaster\@mvclan.de">[MV]DarkViper</a><br>
Website: <a href="http://www.mvclan.de" target="_blank">www.mvclan.de</a>
</font></p>
EOF

# HTML Fuss. Net vernderbar *g*
$html_foot = <<EOF;
 $html_copyright
 </body>
 </html>
EOF

$html_sigline = '<hr noshade size="1">';
##############################################################################
##############################################################################
##############################################################################
##############################################################################
##############################################################################
##############################################################################
##############################################################################
##############################################################################
##############################################################################
##############################################################################
##############################################################################

##############################################################################
#
# Hauptprogramm
#
##############################################################################
get_input(); # Parameter abfragen!
action();
##############################################################################
#
# action
#
##############################################################################
sub action
{
  if    ($f_action eq "view") { view(); }
  elsif ($f_action eq "archiv") { archiv(); }
  elsif ($f_action eq "search") { search(); }
  elsif ($f_action eq "viewentry") { viewentry(); }
  elsif ($f_action eq "admin") { admin(); }
  elsif ($f_action eq "add") { add(); }
  elsif ($f_action eq "preview") { preview(); }
  elsif ($f_action eq "post") { post(); }
  elsif ($f_action eq "edit") { edit(); }
  elsif ($f_action eq "change") { change(); }
  elsif ($f_action eq "del") { del(); }
  elsif ($f_action eq "delbytimeform") { delbytimeform(); }
  elsif ($f_action eq "delbytime") { delbytime(); }
  elsif ($f_action eq "feedback") { viewfeedback(); }
  elsif ($f_action eq "addfeedback") { addfeedback(); }
  elsif ($f_action eq "postfeedback") { postfeedback(); }
  elsif ($f_action eq "adminfeedback") { adminfeedback(); }
  elsif ($f_action eq "delfeedback") { delfeedback(); }
  elsif ($f_action eq "editfeedback") { editfeedback(); }
  elsif ($f_action eq "delallfeedback") { delallfeedback(); }
  elsif ($f_action eq "showenv") { showenv(); }
  
  elsif ($f_action eq "dbconvert") { dbconvert(); }
  
  elsif ($f_action eq "setup") { setup(); }
  elsif ($f_action eq "setconfig") { setconfig(); }
  elsif ($f_action eq "addprofile") { addprofile(); }
  elsif ($f_action eq "postprofile") { postprofile(); }
  elsif ($f_action eq "editprofile") { editprofile(); }
  elsif ($f_action eq "changeprofile") { changeprofile(); }
  elsif ($f_action eq "getpasswd") { getpasswd(); }
  elsif ($f_action eq "submitpasswd") { submitpasswd(); }  
  elsif ($f_action eq "adminprofiles") { adminprofiles(); }
  elsif ($f_action eq "adminprofileedit") { adminprofileedit(); }
  elsif ($f_action eq "adminprofiledel") { adminprofiledel(); }
  
  elsif ($f_action eq "showsmilies") { showsmilies(); }
  elsif ($f_action eq "showmakros") { showmakros(); }
  
  elsif ($f_action eq "editsetuplogin") { editsetuplogin(); }
  
  else { view(); }
}


##############################################################################
#
# view: Anzeigen von News :)
#
##############################################################################
sub view
{
  # Zum Anzeigen des Skriptes mssen wir 1. Datenbank auslesen, und dann
  # eintrag fr Eintrag anzeigen...
  
  # Auslesen der Datenbank
  open(DB, "<$path_news/$file_db") || die error(no_file_db);
  my @NEWS = <DB>;
  close(DB);
  
  # Wir brauchen noch ne Variable, die uns zhlt, wieviel eintrge angezeigt werden
  my $i_show = 0;
  
  # OK, da wir nun die Datenbank im array @NEWS haben, knnen wir die News anzeigen.
  HTTPHead(); if ($i_SSI) { 
    $html_head = '';
    $html_body = '';
    $html_foot = $html_copyright;
    $html_news_headline = '';
    $html_news_footline = '';
  }
  print "$html_head\n$html_body\n$html_news_headline";
  print "<div align=\"center\">"; # HTML Kopf anzeigen
  
  foreach $line (@NEWS) # Die Datenbank Zeile fr Zeile auswerten!
  {
    $i_show++;
    # first splitt off the line
    ($i_count, $i_time, $i_timecrypt, $s_author, $s_email, $s_headline, $s_content) = split(/$gl_sep/, $line);
    # now get out the time of the code!
    ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime($i_time);
    $time_year += 1900; # add 1900 to the year string ;)
    $time_wday += 1; # increase the day of the week by one
    $time_mon_num = $time_mon + 1;    
    #insert that '0' if none!
    if (length($time_min) == 1) { $time_min = "0$time_min"; }
      # Enumerate how many feedbacks we have
      $i_fdbcnt = '';
      open(FDB, "<$path_news/$file_fdb") || die error(no_file_fdb); my @FB = <FDB>; close(FDB);
      # OK, nun die DB durchsuchen, nach dem Eintrag den wir brauchen!
      foreach $fline (@FB)
      {
        chomp($fline); ($i_num, $s_rest) = split (/$gl_sep_3/, $fline); # 1. Aufsplittung!
        # Wenn die 2 Nummern bereinstimmen, Weitermachen!
        if ($i_num == $i_count)
        { @ENTR = split (/$gl_sep_2/, $s_rest); $i_fdbcnt = $#ENTR + 1; }
      }
      unless ($i_fdbcnt) { $i_fdbcnt = '0'; }
    
    # Smilies hinzufgen :)
    unless ($i_HTML_allow) { $s_content =~ s/<([^>]|\n)*>//g; }
    while (($makro, $substitute) = each %hash_makro) { $s_content =~ s/$makro/$substitute/g; }
    if ($i_smilies_allow) { $s_content = addsmilies($s_content); }
    # Aufbau der Tabelle!
    $html_news = $html_table_news;
    $html_news =~ s/%mday/$time_mday/g;
    $html_news =~ s/%mon_num/$time_mon_num/g;
    $html_news =~ s/%mon/$hash_month[$time_mon]/g;
    $html_news =~ s/%year/$time_year/g;
    $html_news =~ s/%hour/$time_hour/g;
    $html_news =~ s/%min/$time_min/g;
    $html_news =~ s/%title/$s_headline/g;
    $html_news =~ s/%content/$s_content/g;
    $html_news =~ s/%name/<a href=\"mailto:$s_email\">$s_author<\/a>/g;
    if ($i_SSI) { $html_news =~ s/%feedback/<a href=# onClick=\"javascript\:fdbwindow = open('$url_script?action=feedback&num=$i_count','prewindow','scrollbars=yes,toolbar=no,height=480,width=640');\">Feedback [$i_fdbcnt]<\/a>/g; } else {
      $html_news =~ s/%feedback/<a href=\"$url_script?action=feedback&num=$i_count\">Feedback [$i_fdbcnt]<\/a>/g;
    }
    
    # Ausgeben der Tabelle!
    print "$html_news";
    
    # Abbrechen, wenn die maximal erlaubte anzahl von eintrgen angezeigt wurde
    unless ($i_show < $i_show_max) { last; }
  }
  
  print "</div>$html_news_footline$html_foot\n"; # HTML Fuss anzeigen
  exit; # Programm beenden
}

##############################################################################
#
# archiv: Anzeigen des Archives
#
##############################################################################
sub archiv
{
  # OK, als erstes das aktuelle Datum bestimmen!
  ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime(time + ($i_timezone * 3600));
  $time_year += 1900; $time_wday += 1; $time_mon += 1;
  unless ($f_day) { $f_day = $time_mday; }
  unless ($f_month) { $f_month = $time_mon; }
  unless ($f_year) { $f_year = $time_year; }
  
 HTTPHead();
  print <<EOF;
  $html_head
  $html_body
  $html_news_headline
  <div align="center">
   <form method=POST action="$url_script">
    <input type=hidden name="action" value="archiv">
    <table border=0 cellpadding="4" cellspacing="0">
    <tr><td><b>News aus der Woche vom:</b></td>
EOF
  print "<td><select name=\"day\">\n";
    for ($counter = 1; $counter <= 31; $counter++) { if ($f_day == $counter) { $s_insert = 'selected'; } else { $s_insert = ''; } print "<option value=\"$counter\" $s_insert>$counter</option>\n"; }
  print "</select></td><td><select name=\"month\">\n";
    for ($counter = 1; $counter <= 12; $counter++) { if ($f_month == $counter) { $s_insert = 'selected'; } else { $s_insert = ''; } print "<option value=\"$counter\" $s_insert>$hash_month[$counter-1]</option>\n"; }
  print "</select></td><td><select name=\"year\">\n";
    for ($counter = $i_date_start; $counter <= $time_year; $counter++) { if ($f_year == $counter) { $s_insert = 'selected'; } else { $s_insert = ''; } print "<option value=\"$counter\" $s_insert>$counter</option>\n"; }
  print "</select></td><td><input type=submit value=\"Anzeigen\" class=\"form2\"></td></tr>\n";
  print "</table></form></div>\n";
  
  print "<div align=\"center\">";
  
  # OK, nun berechnen wir den bereich, aus dem die News angezeigt werden sollen
  $i_range_min = $f_day + ($f_month * 31) + ($f_year * 365);
  $i_range_max = ($f_day + 7) + ($f_month * 31) + ($f_year * 365);
    
  # Auslesen der Datenbank
  open(DB, "<$path_news/$file_db") || die error(no_file_db); my @NEWS = <DB>; close(DB);

  # News schlussendlich anzeigen *g*
  foreach $line (@NEWS) # Die Datenbank Zeile fr Zeile auswerten!
  {
    # first splitt off the line
    ($i_count, $i_time, $i_timecrypt, $s_author, $s_email, $s_headline, $s_content) = split(/$gl_sep/, $line);
    
    # Falls, der Eintrag innerhalb unserer Zeit ist, anzeigen!
    if (($i_timecrypt >= $i_range_min) && ($i_timecrypt <= $i_range_max))
    {
      # now get out the time of the code!
      ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime($i_time);
      $time_year += 1900; # add 1900 to the year string ;)
      $time_wday += 1; # increase the day of the week by one    
      $time_mon_num = $time_mon + 1;    
      #insert that '0' if none!
      if (length($time_min) == 1) { $time_min = "0$time_min"; }
        # Enumerate how many feedbacks we have
        $i_fdbcnt = '';
        open(FDB, "<$path_news/$file_fdb") || die error(no_file_fdb); my @FB = <FDB>; close(FDB);
        # OK, nun die DB durchsuchen, nach dem Eintrag den wir brauchen!
        foreach $fline (@FB)
        {
          chomp($fline); ($i_num, $s_rest) = split (/$gl_sep_3/, $fline); # 1. Aufsplittung!
          # Wenn die 2 Nummern bereinstimmen, Weitermachen!
          if ($i_num == $i_count)
          { @ENTR = split (/$gl_sep_2/, $s_rest); $i_fdbcnt = $#ENTR + 1; }
        }
        unless ($i_fdbcnt) { $i_fdbcnt = '0'; }
        
        #Smilies Hinzufgen
        unless ($i_HTML_allow) { $s_content =~ s/<([^>]|\n)*>//g; }
        while (($makro, $substitute) = each %hash_makro) { $s_content =~ s/$makro/$substitute/g; }
        if ($i_smilies_allow) { $s_content = addsmilies($s_content); }
        # Aufbau der Tabelle!
        $html_news = $html_table_news;
        $html_news =~ s/%mday/$time_mday/g;
        $html_news =~ s/%mon_num/$time_mon_num/g;
        $html_news =~ s/%mon/$hash_month[$time_mon]/g;
        $html_news =~ s/%year/$time_year/g;
        $html_news =~ s/%hour/$time_hour/g;
        $html_news =~ s/%min/$time_min/g;
        $html_news =~ s/%title/$s_headline/g;
        $html_news =~ s/%content/$s_content/g;
        $html_news =~ s/%name/<a href=\"mailto:$s_email\">$s_author<\/a>/g;
        $html_news =~ s/%feedback/<a href=\"$url_script?action=feedback&num=$i_count\">Feedback [$i_fdbcnt]<\/a>/g;
    
        # Ausgeben der Tabelle!
        print "$html_news";
    }
  }
  
  print "</div>$html_news_footline\n$html_foot";
  exit;
}


##############################################################################
#
# search: Durchsuchen der Newsdatenbank
#
##############################################################################
sub search
{
 HTTPHead();
  # OK, HTML Header ausgeben
  print <<EOF;
  $html_head
  $html_body
  $html_news_headline
  <div align="center">
   <form method=POST action="$url_script">
    <input type="hidden" name="action" value="search">
    <table border="0" cellspacing="0" cellpadding="4">
     <tr><td><b>Suchbegriff(e):</b></td>
     <td><input type="text" name="content" value="$f_content" class="form1"></td>
     <td><input type="submit" value="&nbsp;Suchen&nbsp;" class="form2"></td></tr>
    </table>
   </form>
  </div>
  <div align="center">
EOF
  
  unless ($f_content) { print "$html_news_footline\n$html_foot"; exit; }
  else { @SEARCH = split (/ /, $f_content); }
  
  # Auslesen der Datenbank
  open(DB, "<$path_news/$file_db") || die error(no_file_db); my @NEWS = <DB>; close(DB);
  
  foreach $line (@NEWS) # Die Datenbank Zeile fr Zeile auswerten!
  {
    # first splitt off the line
    ($i_count, $i_time, $i_timecrypt, $s_author, $s_email, $s_headline, $s_content) = split(/$gl_sep/, $line);
    
    # Jetzt news durchsuchen *g*
    $i_found = 0;
    foreach $s_search (@SEARCH) { $i_found += $s_content =~ s/$s_search/<font color=red><b>$s_search<\/b><\/font>/ig; }
    unless (($i_found) || ($i_found > 0)) { next; }    #s/<([^>]|\n)*>//g
    
    # now get out the time of the code!
    ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime($i_time);
    $time_year += 1900; # add 1900 to the year string ;)
    $time_wday += 1; # increase the day of the week by one    
    $time_mon_num = $time_mon + 1;    
    #insert that '0' if none!
    if (length($time_min) == 1) { $time_min = "0$time_min"; }
      # Enumerate how many feedbacks we have
      $i_fdbcnt = '';
      open(FDB, "<$path_news/$file_fdb") || die error(no_file_fdb); my @FB = <FDB>; close(FDB);
      # OK, nun die DB durchsuchen, nach dem Eintrag den wir brauchen!
      foreach $fline (@FB)
      {
        chomp($fline); ($i_num, $s_rest) = split (/$gl_sep_3/, $fline); # 1. Aufsplittung!
        # Wenn die 2 Nummern bereinstimmen, Weitermachen!
        if ($i_num == $i_count)
        { @ENTR = split (/$gl_sep_2/, $s_rest); $i_fdbcnt = $#ENTR + 1; }
      }
      unless ($i_fdbcnt) { $i_fdbcnt = '0'; }

    #Smilies Hinzufgen
    unless ($i_HTML_allow) { $s_content =~ s/<([^>]|\n)*>//g; }
    while (($makro, $substitute) = each %hash_makro) { $s_content =~ s/$makro/$substitute/g; }
    if ($i_smilies_allow) { $s_content = addsmilies($s_content); }
    # Aufbau der Tabelle!
    $html_news = $html_table_news;
    $html_news =~ s/%mday/$time_mday/g;
    $html_news =~ s/%mon_num/$time_mon_num/g;
    $html_news =~ s/%mon/$hash_month[$time_mon]/g;
    $html_news =~ s/%year/$time_year/g;
    $html_news =~ s/%hour/$time_hour/g;
    $html_news =~ s/%min/$time_min/g;
    $html_news =~ s/%title/$s_headline/g;
    $html_news =~ s/%content/$s_content/g;
    $html_news =~ s/%name/<a href=\"mailto:$s_email\">$s_author<\/a>/g;
    $html_news =~ s/%feedback/<a href=\"$url_script?action=feedback&num=$i_count\">Feedback [$i_fdbcnt]<\/a>/g;
    
    # Ausgeben der Tabelle!
    print "$html_news";
  }
  
  print "</div>$html_news_footline\n$html_foot";
  exit; # Programmtermination
}


##############################################################################
#
# viewentry: EINEN Eintrag anzeigen
#
##############################################################################
sub viewentry
{
  # Zum Anzeigen des Skriptes mssen wir 1. Datenbank auslesen, und dann
  # eintrag fr Eintrag anzeigen...
  
  # Auslesen der Datenbank
  open(DB, "<$path_news/$file_db") || die error(no_file_db); my @NEWS = <DB>; close(DB);
  
  # OK, da wir nun die Datenbank im array @NEWS haben, knnen wir die News anzeigen.
  HTTPHead();
  print "$html_head\n$html_body";
  print "<div align=\"center\">"; # HTML Kopf anzeigen
  
  foreach $line (@NEWS) # Die Datenbank Zeile fr Zeile auswerten!
  {
    # first splitt off the line
    ($i_count, $i_time, $i_timecrypt, $s_author, $s_email, $s_headline, $s_content) = split(/$gl_sep/, $line);
    if ($i_count == $f_num)
    {
      # now get out the time of the code!
      ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime($i_time);
      $time_year += 1900; # add 1900 to the year string ;)
      $time_wday += 1; # increase the day of the week by one
      $time_mon_num = $time_mon + 1;    
      #insert that '0' if none!
      if (length($time_min) == 1) { $time_min = "0$time_min"; }
        # Enumerate how many feedbacks we have
        $i_fdbcnt = '';
        open(FDB, "<$path_news/$file_fdb") || die error(no_file_fdb); my @FB = <FDB>; close(FDB);
        # OK, nun die DB durchsuchen, nach dem Eintrag den wir brauchen!
        foreach $fline (@FB)
        {
          chomp($fline); ($i_num, $s_rest) = split (/$gl_sep_3/, $fline); # 1. Aufsplittung!
          # Wenn die 2 Nummern bereinstimmen, Weitermachen!
          if ($i_num == $i_count)
          { @ENTR = split (/$gl_sep_2/, $s_rest); $i_fdbcnt = $#ENTR + 1; }
        }
        unless ($i_fdbcnt) { $i_fdbcnt = '0'; }
     
      # Smilies hinzufgen :)
      unless ($i_HTML_allow) { $s_content =~ s/<([^>]|\n)*>//g; }
      while (($makro, $substitute) = each %hash_makro) { $s_content =~ s/$makro/$substitute/g; }
      if ($i_smilies_allow) { $s_content = addsmilies($s_content); }
      # Aufbau der Tabelle!
      $html_news = $html_table_news;
      $html_news =~ s/%mday/$time_mday/g;
      $html_news =~ s/%mon_num/$time_mon_num/g;
      $html_news =~ s/%mon/$hash_month[$time_mon]/g;
      $html_news =~ s/%year/$time_year/g;
      $html_news =~ s/%hour/$time_hour/g;
      $html_news =~ s/%min/$time_min/g;
      $html_news =~ s/%title/$s_headline/g;
      $html_news =~ s/%content/$s_content/g;
      $html_news =~ s/%name/<a href=\"mailto:$s_email\">$s_author<\/a>/g;
      $html_news =~ s/%feedback/<a href=\"$url_script?action=feedback&num=$i_count\">Feedback [$i_fdbcnt]<\/a>/g;
    
      # Ausgeben der Tabelle!
      print "$html_news";
    }
  }
  
  print "</div>$html_foot\n"; # HTML Fuss anzeigen
  exit; # Programm beenden
}


##############################################################################
#
# admin: Anzeigen des Admin bereiches!
#
##############################################################################
sub admin
{
  # Login checken!
  check_login();
  
  # Auslesen der Datenbank
  open(DB, "<$path_news/$file_db") || die error(no_file_db); my @NEWS = <DB>; close(DB);  
  $i_num_entries = $#NEWS + 1;

  # Ausgeben des HTML Headers
  HTTPHead();
  print <<EOF;
  $html_head
  $html_nav
  <div align="center"><b>Eintr&auml;ge insgesamt: $style_marked_b$i_num_entries$style_marked_e</b><br>&nbsp;</div>
  <div align="center">
   <table width="90%" border="1" cellspacing="0" cellpadding="4" bordercolor="$color_table_border">
    <tr bgcolor="$color_table_headline">
     <td><b><i>Datum</i></b></td>
     <td><b><i>Titel</i></b></td>
     <td><b><i>Author</i></b></td>
     <td><b><i>Optionen</i></b></td>
    </tr>
EOF
  
  # nun jede einzelne zeile ausgeben
  foreach $line (@NEWS)
  {
    # first splitt off the line
    ($i_count, $i_time, $i_timecrypt, $s_author, $s_email, $s_headline, $s_content) = split(/$gl_sep/, $line);    
    # now get out the time of the code!
    ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime($i_time);
    $time_year += 1900; # add 1900 to the year string ;)
    $time_wday += 1; # increase the day of the week by one    
    #insert that '0' if none!
    if (length($time_min) == 1) { $time_min = "0$time_min"; }
    print <<EOF;
     <tr bgcolor="$color_table_rest">
      <td>$style_marked_b$time_mday. $hash_month[$time_mon] $time_year, $time_hour:$time_min$style_marked_e</td>
      <td>$style_marked_b$s_headline$style_marked_e</td>
      <td>$style_marked_b<a href="mailto:$s_email">$s_author</a>$style_marked_e</td>
      <td>$style_marked_b<a href="$url_script?action=edit&num=$i_count&login=$f_login&passwd=$f_passwd">edit</a>, <a href="$url_script?action=del&num=$i_count&login=$f_login&passwd=$f_passwd">delete</a>, <a href="$url_script?action=adminfeedback&num=$i_count&login=$f_login&passwd=$f_passwd">feedback</a>$style_marked_e</td>
     </tr>
EOF
  }
  print "</table></div>\n";
  
  # Lschen nach Zeit
#  print "<a name\"delbytime\"></a><div align=\"center\"><br><h3>L&ouml;schen nach Zeit</h3></div>\n";
  

  print "$html_foot";
  exit; # programm termininieren
}

##############################################################################
#
# add: Anzeigen des Formulars zum Hinzufgen von neuen News!
#
##############################################################################
sub add
{
  # Login berprfen...
  check_login();
  if ($i_HTML_allow) { $html_allow = 'Aktiviert'; } else { $html_allow = 'Deaktiviert'; }
  if ($i_smilies_allow) { $smilies_allow = 'Aktiviert'; } else { $smilies_allow = 'Deaktiviert'; }
  
  # OK, there's nothing else to do, than to show up a form, where the user may
  # enter his news *g*
 HTTPHead();
  print <<EOF;
  $html_head
  $html_nav
  <div align="center">
   <form action="$url_script" method="post">
    <input type="hidden" name="login" value="$f_login">
    <input type="hidden" name="passwd" value="$f_passwd">
    <table border="0" cellspacing="0" cellpadding="4">
     <tr><td>
      <table border="1" cellspacing="0" cellpadding="4" bordercolor="$color_table_border">
       <tr><td bgcolor="$color_table_headline"><b>Titel:</b><br><font size="1">Der Titel der News</font></td><td bgcolor="$color_table_rest"><input type="text" name="title" size="40" class="form1"></td></tr>
       <tr><td bgcolor="$color_table_headline"><b>News:</b><br><font size="1">Der News Inhalt.<br><br>HTML ist: <i>$html_allow</i><br><a href=# onClick="javascript:ipwindow = open('$url_script?action=showsmilies','prewindow','scrollbars=yes,toolbar=no,height=480,width=320');">Smilies</a> sind: <i>$smilies_allow</i>
           <br>Makro&uuml;bersicht: <a href=# onClick="javascript:ipwindow = open('$url_script?action=showmakros','prewindow','scrollbars=yes,toolbar=no,height=480,width=320');">hier</a>.</font></td>
         <td bgcolor="$color_table_rest"><textarea name="content" cols="60" rows="10" class="form1"></textarea></td></tr>
       <tr><td bgcolor="$color_table_headline"><b>Optionen:</b><br><font size="1">Weitere Optionen</font></td><td bgcolor="$color_table_rest"><input type="checkbox" name="zeilen"> Zeilenumbr&uuml;che verwerten (zu &lt;br&gt; konvertieren)</td></tr>
      </table>
     </td></tr><tr><td>
      <input type="submit" name="Submit" value="Absenden&nbsp" class="form2">&nbsp;
      <input type=reset value="Zur&uuml;cksetzen" class="form2">
      <input type="hidden" name="action" value="preview">
     </td></tr>
    </table>
   </form>
  </div>
  $html_foot
EOF
  exit; # programm terminieren.
}

##############################################################################
#
# preview: Vorschau anzeigen! *g* :)
#
##############################################################################
sub preview
{
  # Login berprfen...
  check_login();
  unless ($f_email && $f_title && $f_content) { die error(no_param) }
  
  # Sichern der Variablen!
  $f_oldcont = $f_content; $f_oldtitle = $f_title;
  $f_oldcont =~ s/\"/''''/g;
  $f_oldtitle =~ s/\"/''''/g;
  
  # check content !! && prepare title!
  $f_title = prepare($f_title);
  $f_content = check_content($f_content);
  
  # HTML Kopf anzeigen!
 HTTPHead();
  print "$html_head$html_nav<div align=\"center\">";
  
  # OK, jetzt die Tabelle ausgeben!
  ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime(time + ($i_timezone * 3600));
  $time_year += 1900; # add 1900 to the year string ;)
  $time_wday += 1; # increase the day of the week by one    
  #insert that '0' if none!
  if (length($time_min) == 1) { $time_min = "0$time_min"; }
  unless ($i_HTML_allow) { $f_content =~ s/<([^>]|\n)*>//g; }
  while (($makro, $substitute) = each %hash_makro) { $f_content =~ s/$makro/$substitute/g; }
  if ($i_smilies_allow) { $f_content = addsmilies($f_content); }
  # Aufbau der Tabelle!
  $html_news = $html_table_news;
  $html_news =~ s/%mday/$time_mday/g;
  $html_news =~ s/%mon/$hash_month[$time_mon]/g;
  $html_news =~ s/%mon_num/$time_mon+1/g;
  $html_news =~ s/%year/$time_year/g;
  $html_news =~ s/%hour/$time_hour/g;
  $html_news =~ s/%min/$time_min/g;
  $html_news =~ s/%title/$f_title/g;
  $html_news =~ s/%content/$f_content/g;
  $html_news =~ s/%name/<a href=\"mailto:$s_email\">$f_login<\/a>/g;
  $html_news =~ s/%feedback/Feedback/g;
  
  # Ausgeben der Tabelle!
  print "$html_news";
  
  print "</div><div align=\"center\"><table border=0 cellpadding=5 cellspacing=0>";
  print "<tr><td><form method=POST action=\"$url_script\"><input type=submit value=\"&nbsp;&nbsp;Posten&nbsp;&nbsp;\" class=\"form2\">\n";
  print "<input type=\"hidden\" name=\"action\" value=\"post\">\n";
  print "<input type=\"hidden\" name=\"login\" value=\"$f_login\">\n";
  print "<input type=\"hidden\" name=\"passwd\" value=\"$f_passwd\">\n";
  print "<input type=\"hidden\" name=\"title\" value=\"$f_oldtitle\">\n";
  print "<input type=\"hidden\" name=\"content\" value=\"$f_oldcont\">\n";
  print "<input type=\"hidden\" name=\"zeilen\" value=\"$f_zeilen\">\n";
  print "</form></td><td><form><input type=button value=\"&nbsp;&nbsp;Zur&uuml;ck&nbsp;&nbsp;\" onClick=\"javascrript:history.back ()\" class=\"form2\"></form></td></tr>\n";
  print "</table></div>$html_foot";
  
  exit;
}

##############################################################################
#
# post: News posten (zur Datenbank hinzufgen!)
#
##############################################################################
sub post
{
  # Login berprfen...
  check_login();
  unless ($f_email && $f_title && $f_content) { die error(no_param) }
  $f_content =~ s/''''/\"/g;
  $f_content =~ s/$gl_sep/\//g;
  $f_title =~ s/$gl_sep/\//g;
  $f_title =~ s/''''/\"/g;
  $f_title = prepare($f_title);
  
  # check content!
  $f_content = check_content($f_content);
 
  # Als erstes wird der Counter um 1 erhht !!!
  # ffnen der Counterdatei, erhhen des Counters, und zurckschreiben in die Counterdatei!
  open(CNT, "<$path_news/$file_cnt") || die error(no_file_cnt);
  $counter = <CNT>;
  close(CNT);
  $counter++;
  open (CNT, ">$path_news/$file_cnt") || die error(no_file_cnt);
  flock(CNT, 2);
  print CNT "$counter";
  close(CNT);
  
  # Auslesen der Datenbank
  open(DB, "<$path_news/$file_db") || die error(no_file_db);
  my @NEWS = <DB>;
  close(DB);
  
  # ffnen der Datenbank zum Zurckschreiben!
  open(DB, ">$path_news/$file_db") || die error(no_file_db);
  flock(DB, 2);
  
  # zu erst die neue Zeile schreiben
    ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime(time + ($i_timezone * 3600));
    $time_year += 1900; $time_wday += 1; $time_mon += 1;
  my $i_time = time + ($i_timezone * 3600);
  my $i_timecrypt = ($time_year * 365) + ($time_mon * 31) + $time_mday;
  my $s_email = $f_email;
  print DB "$counter$gl_sep$i_time$gl_sep$i_timecrypt$gl_sep$f_login$gl_sep$s_email$gl_sep$f_title$gl_sep$f_content\n";
  
  # und nun den rest schreiben
  foreach $line (@NEWS) { chomp($line); print DB "$line\n"; }
  
  close(DB);
   
  # Weiterleitungsseite schreiben!
 HTTPHead();
  print <<EOF;
    $html_head
    <meta http-equiv="refresh" content="3; URL=$url_script?action=view">
    $html_body
    <div align="center"><font size=4><b>Die News ($counter) werden gepostet...</b></font><br>
    <b>Bitte auf Weiterleitung warten...</b><br>
    $html_foot
EOF

  exit;
}


##############################################################################
#
# edit: editieren eines eintrages (formular anzeigen -> change();)
#
##############################################################################
sub edit
{
  # Login berprfen...
  check_login();
  # berprfen, ob wir alle parameter haben
  unless ($f_num) { die error(no_param); }
  
  if ($i_HTML_allow) { $html_allow = 'Aktiviert'; } else { $html_allow = 'Deaktiviert'; }
  if ($i_smilies_allow) { $smilies_allow = 'Aktiviert'; } else { $smilies_allow = 'Deaktiviert'; }
  
  # Auslesen der Datenbank
  open(DB, "<$path_news/$file_db") || die error(no_file_db);
  my @NEWS = <DB>;
  close(DB);
  
  # Suchen des Eintrags, und Anzeigen des Formulars
  foreach $line (@NEWS)
  {
    # first splitt off the line
    ($i_count, $i_time, $i_timecrypt, $s_author, $s_email, $s_headline, $s_content) = split(/$gl_sep/, $line);
    
    # Falls die 2 Werte bereinstimmen, Formular anzeigen!
    if ($i_count == $f_num)
    {
      # Falls Benutzername & Login nicht bereinstimmen -> Fehler!
      unless($f_admin == 1) { unless ($s_author eq $f_login) { error(perm_denied); }}
 HTTPHead();
      print <<EOF;
      $html_head
      $html_nav
       <div align="center">
        <form method=POST action="$url_script">
        <table border="0" cellspacing="0" cellpadding="4"><tr><td>
         <input type="hidden" name="action" value="change"><input type="hidden" name="num" value="$f_num">
         <input type="hidden" name="login" value="$f_login"><input type="hidden" name="passwd" value="$f_passwd">
         <table border="1" cellspacing="0" cellpadding="4" bordercolor="$color_table_border">
          <tr bgcolor="$color_table_headline"><td><b><i>Beschreibung</i></b></td><td><b><i>Option</i></b></td></tr>
          <tr><td bgcolor="$color_table_headline"><b>Titel:</b><br><font size="1">Der Titel der News</font></td><td bgcolor="$color_table_rest"><input type="text" name="title" value="$s_headline" size="30"></td></tr>
          <tr><td bgcolor="$color_table_headline"><b>News:</b><br><font size="1">Der News Inhalt.<br><br>HTML ist: <i>$html_allow</i><br><a href=# onClick="javascript:ipwindow = open('$url_script?action=showsmilies','prewindow','scrollbars=yes,toolbar=no,height=480,width=320');">Smilies</a> sind: <i>$smilies_allow</i>
           <br>Makro&uuml;bersicht: <a href=# onClick="javascript:ipwindow = open('$url_script?action=showmakros','prewindow','scrollbars=yes,toolbar=no,height=480,width=320');">hier</a>.</font></td><td bgcolor="$color_table_rest"><textarea name="content" cols="41" rows="10">$s_content</textarea></td></tr>
          <tr><td bgcolor="$color_table_headline"><b>Optionen:</b><br><font size="1">Weitere Optionen</font></td><td bgcolor="$color_table_rest"><input type="checkbox" name="zeilen"> Zeilenumbr&uuml;che verwerten (zu &lt;br&gt; konvertieren)</td></tr>
EOF
      if ($f_admin == 1) { print <<EOF;
          <tr><td bgcolor="$color_table_headline"><b>Name:</b><br><font size="1">Der Verfasser der News</font></td><td bgcolor="$color_table_rest"><input type="text" name="chname" value="$s_author" size="30"></td></tr>
          <tr><td bgcolor="$color_table_headline"><b>eMail:</b><br><font size="1">Die eMail des Verfassers</font></td><td bgcolor="$color_table_rest"><input type="text" name="chemail" value="$s_email" size="30"></td></tr>
EOF
      } else { print <<EOF;
          <tr><td bgcolor="$color_table_headline"><b>Name:</b><br><font size="1">Der Verfasser der News</font></td><td bgcolor="$color_table_rest">$style_marked_b$s_author$style_marked_e<input type="hidden" name="chname" value="$s_author" size="30"></td></tr>
          <tr><td bgcolor="$color_table_headline"><b>eMail:</b><br><font size="1">Die eMail des Verfassers</font></td><td bgcolor="$color_table_rest">$style_marked_b$s_email$style_marked_e<input type="hidden" name="chemail" value="$s_email" size="30"></td></tr>
EOF
      }
      print <<EOF;
         </table>
        </td></tr><tr><td>        
         <input type="submit" name="Submit" value="&Auml;ndern" class="form2">&nbsp;<input type=reset value="Zur&uuml;cksetzen" class="form2">
        </td></tr></table>
        </form>
       </div>
      $html_foot
EOF
      last;
    }
  }

  exit; # Programmtermination
}


##############################################################################
#
# change: Letztendliches ndern in der Datenbank
#
##############################################################################
sub change
{
  # Login berprfen...
  check_login();
  # berprfen, ob wir alles haben
  unless ($f_num && $f_title && $f_content && $f_chemail && $f_chname) { die error(no_param); }
  $f_email = prepare($f_chemail); $f_title = prepare($f_title); $f_chemail = prepare($f_chemail);
  $f_content =~ s/$gl_sep/\//g;
  $f_title =~ s/$gl_sep/\//g;
  
  # check content!
  $f_content = check_content($f_content);
  
  # Auslesen der Datenbank
  open(DB, "<$path_news/$file_db") || die error(no_file_db);
  my @NEWS = <DB>;
  close(DB);
  
  # ffnen der Datenbank zum Zurckschreiben!
  open(DB, ">$path_news/$file_db") || die error(no_file_db);
  flock(DB, 2);
  
  # Suchen des Eintrags
  foreach $line (@NEWS)
  {
    # first splitt off the line
    ($i_count, $i_time, $i_timecrypt, $s_author, $s_email, $s_headline, $s_content) = split(/$gl_sep/, $line);
    
    # Falls die 2 Werte bereinstimmen, post!!
    if ($i_count == $f_num) { print DB "$i_count$gl_sep$i_time$gl_sep$i_timecrypt$gl_sep$f_chname$gl_sep$f_chemail$gl_sep$f_title$gl_sep$f_content\n"; }
    else { chomp($line); print DB "$line\n"; }
  }  
  close(DB);
  
  # Weiterleitungsseite schreiben!
 HTTPHead();
  print <<EOF;
    $html_head
    <meta http-equiv="refresh" content="3; URL=$url_script?action=admin&login=$f_login&passwd=$f_passwd">
    $html_body
    <p align="center"><b><font size="4">Die News ($f_num) werden ge&auml;ndert...</font></b><br>
    <b>Bitte auf Weiterleitung warten...</b><br>
    $html_foot
EOF

  exit; # Beenden
}


##############################################################################
#
# del: Lschen eines Eintrags!
#
##############################################################################
sub del
{
  # Login berprfen...
  check_login();
  unless ($f_num) { die error(no_param) } # die if there's no numeric param ;(
  
  # Auslesen der Datenbank
  open(DB, "<$path_news/$file_db") || die error(no_file_db);
  my @NEWS = <DB>;
  close(DB);
  
  # Erstmal berprfen, ob berhaupt die Berechtigung besteht, den Eintrag zu lschen!
  foreach $line (@NEWS) 
  {
    # first splitt off the line
    ($i_count, $i_time, $i_timecrypt, $s_author, $s_email, $s_headline, $s_content) = split(/$gl_sep/, $line);
    if ($i_count == $f_num) { unless($f_admin == 1) { unless ($s_author eq $f_login) { error(perm_denied); }}}
  }
  
  # ffnen der Datei zum zurckschreiben!
  open(DB, ">$path_news/$file_db") || die error(no_file_db);
  flock(DB, 2);
  
  # Jede Zeile zurckschreiben (bis auf die, die zu lschen ist!)
  foreach $line (@NEWS) 
  {
    # first splitt off the line
    ($i_count, $i_time, $i_timecrypt, $s_author, $s_email, $s_headline, $s_content) = split(/$gl_sep/, $line);
    unless ($i_count == $f_num) { chomp($line); print DB "$line\n"; }
  }
  close(DB);
  
  # Weiterleitungsseite schreiben!
 HTTPHead();
  print <<EOF;
    $html_head
    <meta http-equiv="refresh" content="3; URL=$url_script?action=admin&login=$f_login&passwd=$f_passwd">
    $html_body
    <p align="center"><b><font size="4">Die News ($f_num) werden geloescht...</font></b><br>
    <b>Bitte auf Weiterleitung warten...</b><br>
    $html_foot
EOF
  exit;
}


##############################################################################
#
# delbytimeform: Anzeigen des Formulars fr "Loschen nach Zeit"
#
##############################################################################
sub delbytimeform
{
  check_login();
  #berprfen, ob man Admin-Rechte hat!
  unless ($f_admin == 1) { die error(perm_denied); }
  #Ausgeben des Formulars
 HTTPHead();
  print <<EOF;
  $html_head
  $html_nav
  <div align="center">
  <form method=POST action="$url_script">
   <table border=1 cellspacing=0 cellpadding=4 bordercolor="$color_table_border">
    <input type=hidden name="action" value="delbytime">
    <input type=hidden name="login" value="$f_login">
    <input type=hidden name="passwd" value="$f_passwd">
     <tr><td bgcolor="$color_table_headline" colspan="2"><b><i>L&ouml;schen</i></b></td></tr>
     <tr><td bgcolor="$color_table_headline">Alle News, die &auml;lter als n Tage sind, werden gel&ouml;scht.<br>Achtung: 0 l&ouml;scht alle Eintr&auml;ge.</td>
       <td bgcolor="$color_table_rest"><input type=text size=5 name="num" class="form1"></td>
     <tr><td bgcolor="$color_table_rest" colspan="2"><input type=submit value="&nbsp;L&ouml;schen&nbsp;" class="form2">&nbsp;<input type=reset value="Zur&uuml;cksetzen" class="form2"></td></tr>
   </table>
  </form>
  </div>
  $html_foot
EOF
 exit;
}


##############################################################################
#
# delbytime: Lschen von Eintrgen nach einer bestimmten Zeit
#
##############################################################################
sub delbytime
{
  # Login berprfen...
  check_login();
  # berprfen, ob ein parameter bergeben wurde ;)
  unless ($f_num == 0) { unless($f_num) { die error(no_param); } }
  #berprfen, ob man Admin-Rechte hat!
  unless ($f_admin == 1) { die error(perm_denied); }
  
  # Berechnen der Minimalzeit (Unixformat)
  $i_del_days = $f_num * 60 * 60 * 24; # ;)
  $i_del_days = time + ($i_timezone * 3600) - $i_del_days; # so, jetzt haben wir die mindestzeit!
  
  # Auslesen der Datenbank
  open(DB, "<$path_news/$file_db") || die error(no_file_db);
  my @NEWS = <DB>;
  close(DB);
  
  # ffnen der Datei zum zurckschreiben!
  open(DB, ">$path_news/$file_db") || die error(no_file_db);
  flock(DB, 2);
  
  # Jede Zeile zurckschreiben (bis auf die, die zu lschen sind!)
  foreach $line (@NEWS) 
  {
    # first splitt off the line
    ($i_count, $i_time, $i_timecrypt, $s_author, $s_email, $s_headline, $s_content) = split(/$gl_sep/, $line);
    unless ($i_time < $i_del_days) { chomp($line); print DB "$line\n"; }
  }
  close(DB);
  
  # Weiterleitungsseite schreiben!
 HTTPHead();
  print <<EOF;
    $html_head
    <meta http-equiv="refresh" content="3; URL=$url_script?action=admin&login=$f_login&passwd=$f_passwd">
    $html_body
    <p align="center"><b><font size="4">Loeschen von News, die &auml;lter als $f_num Tage sind...</font></b><br>
    <b>Bitte auf Weiterleitung warten...</b><br>
    $html_foot
EOF
  exit;
}


##############################################################################
#
# feedback: Anzeigen des Feedbacks fr einen bestimmten Newseintrag *g*
#           Yeah - We HAVE it! ;)
#
##############################################################################
sub viewfeedback
{
  # berprfen, ob wir alles an parametern haben ;)
  unless ($f_num) { die error(no_param); }
  
  # Ausgeben des HTML Kopfes
 HTTPHead();
  print <<EOF;
  $html_head
  $html_body
  <div align="center"><h1>Feedback</h1></div>
EOF
  
  # ANZEIGEN DER TABELLE BER DEN AKTUELLEN BEITRAG!
  open(DB, "<$path_news/$file_db") || die error(no_file_db); my @NEWS = <DB>; close(DB);
  foreach $line (@NEWS)
  {
    # first splitt off the line
    chomp($line); ($i_count, $i_time, $i_timecrypt, $s_author, $s_email, $s_headline, $s_content) = split(/$gl_sep/, $line);    
    # Falls unser Beitrag gefunden wurde, so anzeigen!
    if ($i_count == $f_num)
    {    
       # now get out the time of the code!
       ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime($i_time);
       $time_year += 1900; # add 1900 to the year string ;)
       $time_wday += 1; # increase the day of the week by one    
       #insert that '0' if none!
       if (length($time_min) == 1) { $time_min = "0$time_min"; }
       print <<EOF;
       <div align="center">
        <table border="1" cellspacing="0" cellpadding="4" bordercolor="$color_table_border">
         <tr><td bgcolor="$color_table_headline">Titel der News:</td><td bgcolor="$color_table_rest">$style_marked_b$s_headline$style_marked_e</td></tr>
         <tr><td bgcolor="$color_table_headline">Gepostet von:</td><td bgcolor="$color_table_rest"><a href="mailto:$s_email">$s_author</a></td></tr>
         <tr><td bgcolor="$color_table_headline">Gepostet am:</td><td bgcolor="$color_table_rest">$style_marked_b$time_mday. $hash_month[$time_mon] $time_year, $time_hour:$time_min$style_marked_e</td></tr>
        </table>
       </div>
EOF
       last;
    }
  }
  
  if ($i_disable_fdb) {  print "<p align=\"center\"><b>Das Feedback System wurde vom <a href=\"mailto:$email_admin\">Webmaster</a> deaktiviert.</b></p>$html_foot"; exit; }

 
  # Nun zwischen die Zeile zum Feedback posten einblenden! 
  $html_fdb_nav_mod = "$html_fdb_nav"; $html_fdb_nav_mod =~ s/%num%/$f_num/g;
  print "$html_fdb_nav_mod\n";
  
  # ANZEIGEN DER FEEDBACKS!
  open(FDB, "<$path_news/$file_fdb") || die error(no_file_fdb); my @FB = <FDB>; close(FDB);
  # OK, nun die DB durchsuchen, nach dem Eintrag den wir brauchen!
  foreach $line (@FB)
  {
    chomp($line); ($i_num, $s_rest) = split (/$gl_sep_3/, $line); # 1. Aufsplittung!
    # Wenn die 2 Nummern bereinstimmen, Weitermachen!
    if ($i_num == $f_num)
    {
      @ENTR = split (/$gl_sep_2/, $s_rest); # So, nun haben wir die einzelnen Beitrge in einem Array!
      # Beitrge sortieren
      @ENTR = sort { ($b =~ /(\d+)$/)[0] <=> ($a =~ /(\d+)$/)[0]} @ENTR;
      # Nun fr jeden Beitrag eine Tabelle anzeigen!
      foreach $entry (@ENTR)
      {
        ($s_name, $s_email, $s_content, $s_IP, $i_time) = split (/$gl_sep/, $entry);
        # now get out the time of the code!
        ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime($i_time);
        $time_year += 1900; # add 1900 to the year string ;)
        $time_wday += 1; # increase the day of the week by one    
        #insert that '0' if none!
        if (length($time_min) == 1) { $time_min = "0$time_min"; }
      
        # berprfen, ob der Benutzer registriert ist
        open(REG, "<$path_news/$file_reg") || die error(no_file_pwd); my @REG = <REG>; close(REG);
        foreach $line (@REG) {
         chomp($line); ($s_usrname, $s_usremail, $s_usrwww, $s_usricq, $s_usrpasswd, $s_usrsignature, $s_usrposts, $s_usrspecial, $i_reg_time) = split(/$gl_sep_3/, $line);
         if ($s_usrname eq $s_name) { $registered = 1; last; } else { $registered = 0; }
        }
        
        # Wenn Registriert -> notieren *g*
        if ($registered) { 
          if ($s_usrspecial eq 'none') { $s_registered = 'registered'; } else { $s_registered = $s_usrspecial; }
          if ($i_ranking && ($s_usrspecial eq 'none')) {
            @RANKINGS = split(/\n/, $s_rankings);
            @RANKINGS = sort { ($b =~ /(\d+)/)[0] <=> ($a =~ /(\d+)/)[0]} @RANKINGS;
            foreach $entry (@RANKINGS) {
             ($rank_num, $rank_title) = split(/\|/, $entry);
             if ($rank_num <= $s_usrposts) { $s_registered = "$rank_title"; last; }
            }
          }
          $s_posts = $s_usrposts;
          ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($i_reg_time); $year+=1900;
          $s_regtime = "$hash_month[$mon], $year";
          $s_IP = 'hidden';
          if ($s_usremail ne '%none%') { $s_name_mod = "<a href=\"mailto:$s_usremail\">$s_name</a>"; } else { $s_name_mod = "$s_name"; }
          unless ($s_usremail eq '%none%') { $email = "<a href=\"mailto:$s_usremail\">$s_usremail</a>"; } else { $email = 'N/A'; }
          unless ($s_usrwww eq '%none%' || $s_usrwww eq 'http://') { $www = "<a href=\"$s_usrwww\" target=\"_blank\">$s_usrwww</a>"; } else { $www = 'N/A'; }
          unless ($s_usricq eq '%none%') { $icq = "<a href=\"http://wwp.mirabilis.com/scripts/Search.dll?to=$s_usricq\">$s_usricq</a>"; } else { $icq = 'N/A'; }
        } else { 
          $s_registered = 'unregistered';
          $s_posts = 'N/A';
          $s_regtime = 'N/A';
          $email = 'N/A';
          $www = 'N/A';
          $icq = 'N/A';
          $s_name_mod = "$s_name";
          if ($i_disable_ip) { $s_IP = 'hidden'; }
        }
        # Wenn keine eMail eingegeben wurde, den namen net verlinken *g*
#        unless ($s_email eq 'noemail') { $s_name_mod = "<a href=\"mailto:$s_email\">$s_name</a>"; } else { $s_name_mod = "$s_name"; }
        # Wenn ne Signatur Existiert -> diese anzeigen (mit allen berprfungen
        if (($registered && $s_usrsignature eq '%none%') || ($registered == 0)) { $s_sigline = ''; $s_signature = ''; } else { 
           $s_signature = "$s_usrsignature";
           $s_sigline = $html_sigline;
           unless ($i_HTML_allow_fdb) { $s_signature = nohtml($s_signature); }
           if ($i_smilies_allow_fdb) { $s_signature = addsmilies($s_signature); } 
        }
        # HTML entfernen (evtl.)
        unless ($i_HTML_allow_fdb) { $s_content = nohtml($s_content); }
        # Smilies Substituten fr den Context
        if ($i_smilies_allow_fdb) { $s_content = addsmilies($s_content); }
        
        # Die Krzel ersetzen
        $html_table_feedback_mod = $html_table_feedback;
        $html_table_feedback_mod =~ s/%content/$s_content/g;
        $html_table_feedback_mod =~ s/%signature/$s_signature/g;
        $html_table_feedback_mod =~ s/%name/$s_name_mod/g;
        $html_table_feedback_mod =~ s/%registered/$s_registered/g;
        $html_table_feedback_mod =~ s/%mday/$time_mday/g;
        $html_table_feedback_mod =~ s/%mon/$hash_month[$time_mon]/g;
        $html_table_feedback_mod =~ s/%year/$time_year/g;
        $html_table_feedback_mod =~ s/%hour/$time_hour/g;
        $html_table_feedback_mod =~ s/%min/$time_min/g;
        $html_table_feedback_mod =~ s/%ip/$s_IP/g;
        $html_table_feedback_mod =~ s/%sigline/$s_sigline/g;
        $html_table_feedback_mod =~ s/%posts/$s_posts/g;
        $html_table_feedback_mod =~ s/%regdate/$s_regtime/g;
        $html_table_feedback_mod =~ s/%website/$www/g;
        $html_table_feedback_mod =~ s/%email/$email/g;
        $html_table_feedback_mod =~ s/%icq/$icq/g;
        
        print <<EOF;
         <div align="center">
          $html_table_feedback_mod
         </div><br>
EOF
      }
      print "$html_foot";
      exit; # Programmtermination
    }
  }

  # Wenn wir hier angekommen sind, so ist kein Feedback vorhanden :((((  
  print "<p align=\"center\"><b>Zu diesem Beitrag existiert noch kein Feedback.</b></p>$html_foot";
  exit;
}


##############################################################################
#
# addfeedback: Anzeigen des Formulars zum Hinzufgen von Feedback!
#
##############################################################################
sub addfeedback
{
  # berprfen, ob wir alles an Parametern haben *g*
  unless ($f_num) { die error(no_param); }
  if ($i_HTML_allow_fdb) { $html_allow = 'Aktiviert'; } else { $html_allow = 'Deaktiviert'; }
  if ($i_smilies_allow_fdb) { $smilies_allow = 'Aktiviert'; } else { $smilies_allow = 'Deaktiviert'; }
  # Ausgeben des HTML Kopfes
 HTTPHead();
  print <<EOF;
  $html_head
  $html_body
  <h1>Feedback posten</h1>
  <div align="center">
   <form method=POST action="$url_script">
    <input type="hidden" name="action" value="postfeedback">
    <input type="hidden" name="num" value="$f_num">
    <table border="0" cellpadding="4" cellspacing="0">
     <tr><td>
      <table border="1" cellspacing="0" cellpadding="4" bordercolor="$color_table_border">
       <tr><td bgcolor="$color_table_headline"><b>Nickname:</b><br><font size="1">Dein Nickname. Ist der Name registriert, ist auch noch ein Passwort erforderlich.</font></td>
        <td bgcolor="$color_table_rest"><input type="text" name="chname" value="$f_login_fdb_ck" class="form1"></td></tr>   
        <tr><td bgcolor="$color_table_headline"><b><i>Passwort</i>:</b><br><font size="1">Dies wird <b>nur</b> bentigt, wenn du deinen Nicknamen registriert hast.</font></td>
        <td bgcolor="$color_table_rest"><input type="password" name="usrpasswd" value="$f_passwd_fdb_ck" class="form1"></td></tr>   
       <tr><td bgcolor="$color_table_headline"><b>Kommentar:</b><br><font size="1">HTML ist: <i>$html_allow</i><br><a href=# onClick="javascript:ipwindow = open('$url_script?action=showsmilies','prewindow','scrollbars=yes,toolbar=no,height=480,width=320');">Smilies</a> sind: <i>$smilies_allow</i></font></td>
        <td bgcolor="$color_table_rest"><textarea name="content" cols="30" rows="5" class="form1"></textarea></td></tr>   
      </table>
     </tr></td><tr><td>
      <input type="submit" name="Submit" value="Hinzuf&uuml;gen" class="form2">&nbsp;<input type="reset" name="Submit2" value="Zur&uuml;cksetzen" class="form2">
     </td></tr>
    </table>
   </form>
  </div>
  $html_foot
EOF
}


##############################################################################
#
# postfeedback: Feedback schlussendlich posten :)
#
##############################################################################
sub postfeedback
{
  # berprfen, ob wir alles an Parametern haben *g*
  unless ($f_num) { die error(no_param); }
  unless ($f_chname) {$f_chname = 'Anonymous';}
  unless ($f_content) {$f_content = 'Kein Text eingegeben';}
  unless ($f_chemail) {$f_chemail = 'noemail';}
  $f_content =~ s/\n/<br>/g;
  $f_content =~ s/$gl_sep/\//g;
  $i_time = time + ($i_timezone * 3600); # Zeit bestimmen!
  $s_IP = $ENV{'REMOTE_ADDR'};
  
  # Schauen, ob der User registriert ist *g*
  open(REG, "<$path_news/$file_reg") || die error(no_file_pwd); my @REG = <REG>; close(REG);  
  foreach $line (@REG) {
   chomp($line); ($s_usrname, $s_usremail, $s_usrwww, $s_usricq, $s_usrpasswd, $s_usrsignature, $s_usrposts, $s_usrspecial, $i_reg_time) = split(/$gl_sep_3/, $line);
    if ($f_chname eq $s_usrname) { $registered = 1; last; } else { $registered = 0; }
  }
  
  if ($registered) { unless ($f_usrpasswd eq $s_usrpasswd) { die error(bad_reg_login_add); } }
  if ($registered) { incposts($f_chname); }  
#  if ($registered) { $f_chemail = $s_usremail; }
  if (!$registered && ($f_usrpasswd ne '')) { $f_usrpasswd = ''; }
  
  # Cookie Setzen :)
  $i_setfdbpasscook = 1;
  $f_login = $f_chname;
  $f_passwd = $f_usrpasswd;
  
  # Scheint so *g*, also Datenbank ffnen!
  open(FDB, "<$path_news/$file_fdb") || die error(no_file_fdb); my @FB = <FDB>; close(FDB);
  open(FDB, ">$path_news/$file_fdb") || die error(no_file_fdb);
  # OK, nun die DB durchsuchen, nach dem Eintrag den wir brauchen, wenna nicht gefunden wurde, grad zurckschreiben
  foreach $line (@FB)
  {
    chomp($line); ($i_num, $s_rest) = split (/$gl_sep_3/, $line); # 1. Aufsplittung!
    # Wenn die 2 Nummern bereinstimmen, Weitermachen. Ansonsten zurckschreiben
    if ($i_num == $f_num)
    {
      # Hehe, einfach unseren neuen Eintrag anhngen *g*
      print FDB "$line$gl_sep_2$f_chname$gl_sep$f_chemail$gl_sep$f_content$gl_sep$s_IP$gl_sep$i_time\n"; # *g*
      $b_found = "found";
    } else { print FDB "$line\n"; }
  }  
  # berprfen, ob berhaupt ein Eintrag gefunden wurden, wenn nicht, einen generieren
  unless ($b_found eq 'found') { print FDB "$f_num$gl_sep_3$f_chname$gl_sep$f_chemail$gl_sep$f_content$gl_sep$s_IP$gl_sep$i_time\n"; }
  close(FDB);
  
  # Weiterleitungsseite schreiben!
 HTTPHead();
  print <<EOF;
    $html_head
    <meta http-equiv="refresh" content="3; URL=$url_script?action=feedback&num=$f_num">
    $html_body
    <p align="center"><b><font size="4">Vielen Dank f&uuml;r den Beitrag, $f_chname...</font></b><br>
    <b>Bitte auf Weiterleitung warten...</b><br>
    $html_foot
EOF
  exit;
}


##############################################################################
#
# adminfeedback: Feedbackadministration zu einem bestimmten Feedback eintrag
#
##############################################################################
sub adminfeedback()
{
  # Login checken
  check_login();
  # berprfen, ob wir alles an Parametern haben!
  unless ($f_num) { die error(no_param); }
  
  # OK, header ausgeben
 HTTPHead();
  print <<EOF;
  $html_head
  $html_nav
  <p align="center"><b>[ <a href="$url_script?action=delallfeedback&num=$f_num&login=$f_login&passwd=$f_passwd">Alles L&ouml;schen</a> ]</b></p>
EOF
  
  # Feedbackdatenbank auslesen
  open(FDB, "<$path_news/$file_fdb") || die error(no_file_fdb); my @FB = <FDB>; close(FDB);
  print <<EOF;
  <div align="center">
   <table width="90%" border="1" cellspacing="0" cellpadding="4" bordercolor="$color_table_border">
    <tr bgcolor="$color_table_headline">
     <td><b><i>Name</i></b></td>
     <td><b><i>IP Adresse</i></b></td>
     <td><b><i>Optionen</i></b></td>
    </tr>
EOF
   
  # OK, nun die DB durchsuchen, nach dem Eintrag den wir brauchen!
  foreach $line (@FB)
  {
    chomp($line); ($i_num, $s_rest) = split (/$gl_sep_3/, $line); # 1. Aufsplittung!
    # Wenn die 2 Nummern bereinstimmen, Weitermachen!
    if ($i_num == $f_num)
    {
      @ENTR = split (/$gl_sep_2/, $s_rest); # So, nun haben wir die einzelnen Beitrge in einem Array!
      # Beitrge sortieren
      @ENTR = sort { ($b =~ /(\d+)$/)[0] <=> ($a =~ /(\d+)$/)[0]} @ENTR;
      
      # Nun jeden Eintrag inner Tabelle anzeigen
      foreach $entry (@ENTR)
      {
        ($s_name, $s_email, $s_content, $s_IP, $i_time) = split (/$gl_sep/, $entry);# Split
        print <<EOF;
         <tr bgcolor="$color_table_rest">
          <td>$style_marked_b$s_name$style_marked_e</td>
          <td>$style_marked_b$s_IP$style_marked_e</td>
          <td>$style_marked_b<a href="$url_script?action=delfeedback&num=$f_num&chname=$s_name&content=$i_time&login=$f_login&passwd=$f_passwd">delete</a>$style_marked_e</td>
         </tr>
EOF
      }
    }
  }  
  
  # Ausgeben der Buttons
  print <<EOF;
    </table></div>
   $html_foot
EOF
  exit; # Programmtermination
}


##############################################################################
#
# delfeedback: Lschen eines Feedbackeintrags
#
##############################################################################
sub delfeedback
{
  # Login checken
  check_login();
  # Auf Admin rechte prfen
  unless ($f_admin == 1) { die error(perm_denied); }
  # berprfen, ob wir alles an Parametern haben!
  unless ($f_num && $f_chname && $f_content) { die error(no_param); }
 
  # Feedbackdatenbank auslesen
  open(FDB, "<$path_news/$file_fdb") || die error(no_file_fdb); my @FB = <FDB>; close(FDB);
  open(FDB, ">$path_news/$file_fdb") || die error(no_file_fdb);
  # OK, nun die DB durchsuchen, nach dem Eintrag den wir brauchen!
  foreach $line (@FB)
  {
    chomp($line); ($i_num, $s_rest) = split (/$gl_sep_3/, $line); # 1. Aufsplittung!
    unless($i_num == $f_num) { print FDB "$line\n"; }
    else
    {
      @ENTR = split (/$gl_sep_2/, $s_rest); # So, nun haben wir die einzelnen Beitrge in einem Array!
      # OK, erstellen einer neuen Variable!
      $newline = "$i_num$gl_sep";
      
      # Nun jeden Eintrag inner Tabelle anzeigen
      foreach $entry (@ENTR)
      {
        ($s_name, $s_email, $s_content, $s_IP, $i_time) = split (/$gl_sep/, $entry);# Split
        unless (($f_content == $i_time) && ($f_chname eq $s_name)) { 
          unless ($newline) { $newline = "$i_num$gl_sep_3$s_name$gl_sep$s_email$gl_sep$s_content$gl_sep$s_IP$gl_sep$i_time"; }
          else { $newline = "$newline$gl_sep_2$s_name$gl_sep$s_email$gl_sep$s_content$gl_sep$s_IP$gl_sep$i_time"; }
          $b_written = "true";          
        }
      }
      if ($b_written eq 'true') { print FDB "$newline\n"; }
    }
  }
  close (FDB);
  
  # Weiterleitungsseite schreiben!
 HTTPHead();
  print <<EOF;
    $html_head
    <meta http-equiv="refresh" content="3; URL=$url_script?action=adminfeedback&num=$f_num&login=$f_login&passwd=$f_passwd">
    $html_body
    <p align="center"><b><font size="4">Feedbackeintrag wird gel&ouml;scht.</font></b><br>
    <b>Bitte auf Weiterleitung warten...</b><br>
    $html_foot
EOF
  exit;
}


##############################################################################
#
# delallfeedback: Lschen aller Feedback eintrge fr einen Beitrag!
#
##############################################################################
sub delallfeedback
{
  # Login checken
  check_login();
  # Auf Admin rechte prfen
  unless ($f_admin == 1) { die error(perm_denied); }
  # berprfen, ob wir alles an Parametern haben!
  unless ($f_num) { die error(no_param); }
  
  # Feedbackdatenbank auslesen
  open(FDB, "<$path_news/$file_fdb") || die error(no_file_fdb); my @FB = <FDB>; close(FDB);
  open(FDB, ">$path_news/$file_fdb") || die error(no_file_fdb);
  # OK, nun die DB durchsuchen, nach dem Eintrag den wir brauchen! (Der natrlich nicht zurckgeschrieben wird)
  foreach $line (@FB)
  {
    chomp($line); ($i_num, $s_rest) = split (/$gl_sep_3/, $line); # 1. Aufsplittung!
    unless($i_num == $f_num) { print FDB "$line\n"; }
  }
  close (FDB);
  
  # Weiterleitungsseite schreiben!
 HTTPHead();
  print <<EOF;
    $html_head
    <meta http-equiv="refresh" content="3; URL=$url_script?action=adminfeedback&num=$f_num&login=$f_login&passwd=$f_passwd">
    $html_body
    <p align="center"><b><font size="4">Alle Feedbackeintr&auml;ge zu den News $f_num werden gel&ouml;scht.</font></b><br>
    <b>Bitte auf Weiterleitung warten...</b><br>
    $html_foot
EOF
  exit;
}


##############################################################################
#
# error: Fehlerbehandlung des Skriptes! ;) Hoffentlich wird das nie ausgefhrt
#
##############################################################################
sub error
{
  $error = $_[0]; # kopieren des 1. Parameters in eine Variable
  
 HTTPHead();
  print <<EOF; # anzeigen des headers / bodies
  $html_head
  $html_body
  <div align="left">
  <font face="Arial, Helvetica" size="5"><b>Fehler in $url_script</b></font>
  <blockquote><br>
    <font face="Arial Helvetica" size="2"><b>$style_marked_b
EOF

#  # berprfen welcher Fehler aufgetreten ist, und die entsprechende Meldung ausspucken
  if ($error eq 'no_param') { print "Es wurden zu wenige, ung&uuml;ltige oder keine Parameter dem CGI skript uebergeben. Handelt es sich um eine Formulareingabe, &uuml;berpr&uuml;fen Sie bitte, ob sie alle Felder ausgef&uuml;llt haben!!"; }
  elsif ($error eq 'form') { print "Die Formular eingabe war unvollst&auml;ndig. Bitte den 'Zur&uuml;ck' Button des Browsers dr&uuml;cken, um zu der Eingabe zur&uuml;ckzukehren"; }
  elsif ($error eq 'no_file_pwd') { print "Die Passwortdatei <b>$path_news/$file_pwd</b> wurde nicht gefunden."; }
  elsif ($error eq 'no_file_db') { print "Die Datenbankdatei <b>$path_news/$file_db</b> wurde nicht gefunden."; }
  elsif ($error eq 'no_file_cnt') { print "Die Counterdatei <b>$path_news/$file_cnt</b> wurde nicht gefunden."; }
  elsif ($error eq 'no_file_fdb') { print "Die Feedbackdatei <b>$path_news/$file_fdb</b> wurde nicht gefunden."; }
  elsif ($error eq 'no_file_log') { print "Die Logdatei <b>$path_news/$file_log</b> konnte nicht zum schreiben ge&ouml;ffnet werden."; }
  elsif ($error eq 'no_file_reg') { print "Die Regdatei <b>$path_news/$file_reg</b> konnte nicht ge&ouml;ffnet werden."; }
  elsif ($error eq 'bad_login') { print "Die Kombination von Benutzername und Kennwort war ung&uuml;ltig. Der Webmaster wurde informiert."; }
  elsif ($error eq 'bad_reg_login') { print "Die Kombination von Benutzername und Kennwort war ung&uuml;ltig."; }
  elsif ($error eq 'bad_reg_login_add') { print "Es wurde ein falsches Passwort f&uuml;r einen registrierten Namen eingegeben. Bitte den 'Zur&uuml;ck' Button des Browsers dr&uuml;cken, um zu der Eingabe zur&uuml;ckzukehren."; }
  elsif ($error eq 'perm_denied') { print "<b>Permission Denied:</b> Sie haben nicht die Berechtigung diese Funktion auszuf&uuml;hren..."; }
  elsif ($error eq 'nq_passwd') { print "Die Passw&ouml;rter stimmten nicht &uuml;berein. Bitte \"Back\"taste am Browser dr&uuml;cken..."; }
  elsif ($error eq 'usr_exists') { print "Der Benutzer existiert bereits in der Datenbank!"; }
  elsif ($error eq 'usr_no_exists') { print "Der Benutzer existiert nicht in der Datenbank!"; }
  elsif ($error eq 'char') { print "Bei der Eingabe wurde ein ungltiges Zeichen verwendet. In den meisten F&auml;llen handelt es sich dabei um das '|' Zeichen, welches nicht zul&auml;ssig ist!"; }
  else { print "Es ist ein unbekannter Fehler aufgetreten! :("; }
  
  print <<EOF; # anzeigen des fusses!
    $style_marked_e</b></font>
  </blockquote>
  <font face="Arial, Helvetica" size="2">
   Bitte konsultieren Sie den <a href="mailto:$email_admin">Webmaster</a> der Site, oder den <a href="mailto:webmaster\@mvclan.de">Urheber</a> des Skriptes, und informieren Sie ihn mit der genauen Fehlermeldung.
  </font> 
  <hr>
  <font face="Arial, Helvetica" size="2">
  <b>Server at:</b> $ENV{'HTTP_HOST'}<br>
  <b>Admin:</b> <a href="mailto:$ENV{'SERVER_ADMIN'}">$ENV{'SERVER_ADMIN'}</a><br>
  <b>Webmaster:</b> <a href="mailto:$email_admin">$email_admin</a>
  </font>
  </div>
  $html_foot
EOF

  exit;
}


##############################################################################
#
# showenv: Anzeigen der Environment vars *g*
#
##############################################################################
sub showenv
{
  # Header ausgeben
 HTTPHead();
  print "$html_head$html_body";
  print "$style_heading_b Environment Variablen$style_heading_e\n";
  print "<div align=\"center\"><table border=0 cellpadding=5 cellspacing=0>\n";
  while (($var, $varcont) = each %ENV) { print "<tr><td><b>$var:</b></td><td>$style_marked_b$varcont$style_marked_e</td></tr>\n"; }
  print "</table></div>";
  print "$html_foot";
  exit;
}


##############################################################################
#
# dbconvert: DB in das neue format konvertieren
#
##############################################################################
sub dbconvert
{
 @FILES = ('news.dat', 'news.fdb', 'news.reg');
 
 foreach $file (@FILES) {
  open (FILE, "<$path_news/$file") || die; @ARRAY = <FILE>; close(FILE);
  open (FILE, ">$path_news/$file") || die;
   foreach $line (@ARRAY) { chomp($line);
    $line =~ s/\|\|\|/$gl_sep_3/g;
    $line =~ s/\|\|/$gl_sep_2/g;
    $line =~ s/\|/$gl_sep/g;
    print FILE "$line\n";
   }
  close (FILE);
 }
 view();
}


##############################################################################
#
# check_content: check the content of a var (because of HTML)
#
##############################################################################
sub check_content
{
 $input = $_[0];
  $input =~ s/\cM//g; # ??
  if ($f_zeilen eq 'on') { $input =~ s/\n/<br>/g;}
  #$input =~ s/\n\n+/<p>/g; # replace \n\n (line feeds) by <p>
  $input =~ s/\n//g; # remove any line feeds!
  $input =~ s/<!--(.|\n)*-->//g; # remove script tags
  $input =~ s/$gl_sep/\//g;
 return($input);
}


##############################################################################
#
# prepare: Vorbereiten auf Ausgabe *g*
#
##############################################################################
sub prepare
{
  # kopieren des 1. Parameters in eine Variable
  $input = $_[0];
  
  $input =~ s/<([^>]|\n)*>//g; # Entfernen jeglichen HTMLs
  $input =~ s/\n/<br>/g; # Ersetzen von \n durch <br>
  $input =~ s/<!--(.|\n)*-->//g; # Entfernen jeglicher skripttags!
  $input =~ s/\"/&quot;/g; # Entfernen von Anfhrungszeichen!
  return($input);
}

##############################################################################
#
# chek_login: Login berprfen, und gegebenfalls anzeigen :)
#
##############################################################################
sub check_login
{
  # berprfen ob Login - Infos mit bertragen wurde. (Wenn nicht, zur Eingabe auffordern)
  unless ($f_login || $f_passwd)
  {
   HTTPHead();
    print <<EOF;
    $html_head
    $html_body
    <div align="center"><h1>Member Login</h1></div>
     <form method=post action="$url_script"><input type=hidden name="action" value="$f_action">
      <div align="center">
       <table border="1" cellspacing="0" cellpadding="4" bordercolor="$color_table_border">
        <tr><td bgcolor="$color_table_headline"><b><i>Username:</i></b></td><td bgcolor="$color_table_rest"><input type=text name="login" value="$f_login_ck" class="form1"></td></tr>
        <tr><td bgcolor="$color_table_headline"><b><i>Passwort:</i></b></td><td bgcolor="$color_table_rest"><input type=password name="passwd" value="$f_passwd_ck" class="form1"></td></tr>
        <tr><td bgcolor="$color_table_rest" colspan="2"><div align="center"><input type=submit value="&nbsp;Einloggen&nbsp;" class="form2"> <input type=reset value="Zur&uuml;cksetzen" class="form2"></div></td></tr>
       </table>
      </div>
     </form>
    $html_foot
EOF
    exit;
  }
  
  # OK, anscheinend wurden infos submittet... Let's check for PWD!
  # Auslesen der Datenbank
  open(PWDFILE, "<$path_news/$file_pwd") || die error(no_file_pwd);
  my @PWD = <PWDFILE>;
  close(PWDFILE);
  
  # Suchen des Benutzereintrags!
  foreach $line (@PWD)
  {
    chomp ($line); ($s_login, $sc_passwd, $b_crypt, $f_email, $f_admin) = split(/:/, $line); # Erstmal Linie splitten!
    $s_salt = substr($f_login, 0, 2); # Schlssel definieren ;)
    if ($b_crypt == 1) {$s_testpwd = crypt($f_passwd, $s_salt);} else {$s_testpwd = $f_passwd;}
    if (($s_testpwd eq $sc_passwd) && ($f_login eq $s_login)) { $i_setpasscook = 1; return; } # berprfung der PWDs & Benutzernamen
  }
  
  # Fehler spucken, wenn das Login falsch ist
  # Aber vorher ne eMail senden *g* ;-)
  ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime(time + ($i_timezone * 3600)); $time_year += 1900; $time_wday += 1; $time_mon += 1;
  open (SENDMAIL, "| $path_sendmail -t");
  print SENDMAIL "To: Webmaster <$email_admin>\n";
  print SENDMAIL "From: $path_script <$email_admin>\n";
  print SENDMAIL "Subject: Falsche Passworteingabe\n\n";
  print SENDMAIL <<EOF;
Warnung:
Fuer den Adminbereich des News Scriptes wurde eine falsche Login / Passwort - Kombination eingegeben:

Username: $f_login
Passwort: $f_passwd
IP: $ENV{'REMOTE_ADDR'}
Browser: $ENV{'HTTP_USER_AGENT'}
Datum: $time_mday.$time_mon.$time_year, $time_hour:$time_min.$time_sec

Sollten solche Vorfaelle oefters vorkommen, so ist eine haeufigere Aenderung von Benutzername / Kennwort empfohlen.
Fuer weitere Fragen kontakten Sie bitte [MV]DarkViper.
--------------------------------
News - Script by: [MV]DarkViper
eMail: webmaster\@mvclan.de
Webpage: www.mvclan.de
EOF
  close (SENDMAIL);
  die error(bad_login); # :((((
}

##############################################################################
#
# get_input: Retrieve the Parameters! This is sucky complicated :(
#
##############################################################################
sub get_input
{
  $f_action = $req->param('action');
  $f_day = $req->param('day');
  $f_month = $req->param('month');
  $f_year = $req->param('year');
  
  $f_chname = $req->param('chname');
  $f_title = $req->param('title');
  $f_content = $req->param('content');
  $f_chemail = $req->param('chemail');
  $f_num = $req->param('num');
  
  $f_login = $req->param('login');
  $f_passwd = $req->param('passwd');
  
  $f_usrname = $req->param('usrname');
  $f_usremail = $req->param('usremail');
  $f_usrpasswd = $req->param('usrpasswd');
  $f_usrpasswd2 = $req->param('usrpasswd2');
  $f_usrcrypt = $req->param('usrcrypt');
  $f_usradmin = $req->param('usradmin');
  $f_usrwww = $req->param('usrwww');
  $f_usricq = $req->param('usricq');
  $f_usrsignature = $req->param('usrsignature');
  $f_usrposts = $req->param('usrposts');
  $f_usrspecial = $req->param('usrspecial');
  
  $f_zeilen = $req->param('zeilen');
  $f_newsetuplogin = $req->param('newsetuplogin');

  $i_setpasscook = 0;
  $f_login_ck = $req->cookie('CK_LOGIN');
  $f_passwd_ck = $req->cookie('CK_PASSWD'); 
  
  $i_setfdbpasscook = 0;
  $f_login_fdb_ck = $req->cookie('CK_FDB_LOGIN');
  $f_passwd_fdb_ck = $req->cookie('CK_FDB_PASSWD');
  
  # Titel ersetzen
  if ($f_action eq 'admin') { $html_nav =~ s/%title%/Administration, $f_login/g; }
  elsif ($f_action eq 'add') { $html_nav =~ s/%title%/Hinzuf&uuml;gen, $f_login/g; }
  elsif ($f_action eq 'preview') { $html_nav =~ s/%title%/Vorschau, $f_login/g; }
  elsif ($f_action eq 'edit') { $html_nav =~ s/%title%/Editieren, $f_login/g; }
  elsif ($f_action eq 'adminfeedback') { $html_nav =~ s/%title%/Feedback, $f_login/g; }
  elsif ($f_action eq 'showlog') { $html_nav =~ s/%title%/Logfile, $f_login/g; }
  elsif ($f_action eq 'adminprofiles') { $html_nav =~ s/%title%/Profile, $f_login/g; }
  elsif ($f_action eq 'adminprofileedit') { $html_nav =~ s/%title%/Profile Editieren, $f_login/g; }
  else { $html_nav =~ s/%title%//g; }
  
  $html_nav =~ s/%login%/$f_login/g;
  $html_nav =~ s/%passwd%/$f_passwd/g;
}


##############################################################################
#
# HTTPHead: Einfgen login/passwd in HREFs im Navigationskopf
#
##############################################################################
sub HTTPHead()
{
  
	if ($i_setpasscook){
	        $f_login_ck = $req->cookie(-name=>'CK_LOGIN',
	                                   -value=>$f_login,
	                                   -expires=>"+1y",
	                                   -path=>"/cgi-bin",
	                                   -domain=>"$ENV{'HTTP_HOST'}");
	        $f_passwd_ck = $req->cookie(-name=>'CK_PASSWD',
	                                    -value=>$f_passwd,
	                                    -expires=>"+1y",
	                                    -path=>"/cgi-bin",
	                                    -domain=>"$ENV{'HTTP_HOST'}");
	 print "Content-type: text/html\n";
	 print $req->header(-cookie=>[$f_login_ck,$f_passwd_ck]);
	} elsif ($i_setfdbpasscook) {
	        $f_login_fdb_ck = $req->cookie(-name=>'CK_FDB_LOGIN',
	                                   -value=>$f_login,
	                                   -expires=>"+1y",
	                                   -path=>"/cgi-bin",
	                                   -domain=>"$ENV{'HTTP_HOST'}");
	        $f_passwd_fdb_ck = $req->cookie(-name=>'CK_FDB_PASSWD',
	                                    -value=>$f_passwd,
	                                    -expires=>"+1y",
	                                    -path=>"/cgi-bin",
	                                    -domain=>"$ENV{'HTTP_HOST'}");
	 print "Content-type: text/html\n";
	 print $req->header(-cookie=>[$f_login_fdb_ck,$f_passwd_fdb_ck]);
    }
	else{
	       print "Content-type: text/html\n\n";}
}
##############################################################################
##############################################################################
##############################################################################
##############################################################################
##############################################################################
##############################################################################
##############################################################################

##############################################################################
#
# redirection: weiterleitungsseite schreiben
#
##############################################################################
sub redirection
{
  $param = $_[1];
  unless ($param) {$param = 'view'};
  # Dies ist nur HTML zeugs
 HTTPHead();
  print <<EOF;
  $html_head
  <meta http-equiv="refresh" content="2; URL=$url_script?action=$param">
  $html_body
  <div align="center"><font size=4><b>$_[0]</b></font><br>
  <b>Bitte auf Weiterleitung warten.</b></div>
  $html_foot
EOF
}

##############################################################################
#
# setup: konfigurieren des scriptes.
#
##############################################################################
sub setup
{
 loginsetup();
 # ok, prepare some stuff
 if ($i_HTML_allow) { $checked_i_HTML_allow = 'checked'; }
 if ($i_HTML_allow_fdb) { $checked_i_HTML_allow_fdb = 'checked'; }
 if ($i_smilies_allow) { $checked_i_smilies_allow = 'checked'; }
 if ($i_smilies_allow_fdb) { $checked_i_smilies_fdb_allow = 'checked'; }
 if ($i_disable_fdb) { $checked_i_disable_fdb = 'checked'; }
 if ($i_ranking) { $checked_i_ranking = 'checked'; }
 if ($i_disable_ip) { $checked_i_disable_ip = 'checked'; }
 if ($i_SSI) { $checked_i_SSI = 'checked'; }
 
 # anzeigen der ganzen misere
 HTTPHead();
 print <<EOF;
 $html_head
 $html_body
 <div align="center"><font size="5"><b>News Script Setup</b></font><br><b>Script Version</b>: $script_version</div>
 <blockquote><br>
  Das Script kann &uuml;ber dieses Interface eingerichtet und konfiguriert werden. Das Setup-Interface ist der <b>einzige</b> Teil vom Script der auch funktioniert, wenn die ganzen Pfadangaben usw. inkorrekt sind. Es empfielt sich immer nur eine
  Einstellung zur selben Zeit zu machen, und danach das Script erstmal zu testen.
 </blockquote>
 <p align="center"><font size="1">
  [ <a href="#pwd">Passwort</a> ] &#149; [ <a href="#url">URLs, Pfade, eMail</a> ] &#149; [ <a href="#all">Allgemeines</a> ] &#149; 
  [ <a href="#new">News / Feedback</a> ] &#149; [ <a href="#far">Farbe / Design</a> ] &#149; [ <a href="#smi">Smilies / Makros</a> ] &#149; [ <a href="#htm">HTML</a> ]
 </font></p>
 <div align="center">
  <form method="POST" action="$url_script">
   <table width="80%" border="1" cellspacing="0" cellpadding="4" bordercolor="$color_table_border">
   <tr><td bgcolor="$color_table_headline" colspan="2"><b><i><a name="pwd"></a>Setup Login Passwort</i></b></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Setup Passwort:</b><br><font size="1">Das Passwort um hier einzuloggen. Bitte auf keinen Fall an Dritte weitergeben.</font></td>
     <td bgcolor="$color_table_rest"><input type="password" name="setup_passwd" value="$s_setup_passwd" class="form1"></td></tr>   
   <tr><td colspan="2" bgcolor="$style_border" height="5"></tr>
   <tr><td bgcolor="$color_table_headline" colspan="2"><b><i><a name="url"></a>URLs, Pfade, eMail</i></b></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>URL zum Script:</b><br><font size="1">Die URL des Scriptes. Diese Einstellung stimmt in der Regel, und erfordert keine Ab&auml;nderung.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="url_script" value="$url_script" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>Pfad zur Datenbank:</b><br><font size="1">Der <b>absolute</b> Serverpfad zur Datenbank die mit dem Script ausgeliefert wurde. Der Serverpfad kann eventuell hiermit ermittelt werden.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="path_news" value="$path_news" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>Name d. Passwortdatei:</b><br><font size="1">Der Dateiname der Passwortdatei.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="file_pwd" value="$file_pwd" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>Pfad zu Sendmail:</b><br><font size="1">Wird fr den Versand von eMails ben&ouml;tigt.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="path_sendmail" value="$path_sendmail" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>URL zu den Smilies:</b><br><font size="1">Die URL zu dem Verzeichnis, wo sich die Smilies befinden.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="url_smilies" value="$url_smilies" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>eMail des Webmasters:</b><br><font size="1">Die eMail Adresse des Webmasters der Seite, auf der das Script eingesetzt wird.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="email_admin" value="$email_admin" class="form1"></td></tr>   
   <tr><td colspan="2" bgcolor="$style_border" height="5"></tr>
   <tr><td bgcolor="$color_table_headline" colspan="2"><b><i><a name="all"></a>Allgemeine Einstellungen</i></b></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Zeitzone:</b><br><font size="1">Dies stellt nicht die Zeitzone dar, sondern die Anzahl in Stunden, die die Serverzeit von der eigentlichen Zeit abweicht. Bei einer Eingabe von '1' wird eine Stunde dazuaddiert, bei '-4' 4 Stunden subtrahiert.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="i_timezone" value="$i_timezone" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>Anzahl News:</b><br><font size="1">Die maximale Anzahl News, die auf der Hauptseite angezeigt werden. &Auml;ltere News k&ouml;nnen &uuml;ber das Archiv abgerufen werden.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="i_show_max" value="$i_show_max" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>Startjahr d. News:</b><br><font size="1">Gibt das Jahr an, in welchem das News Script installiert wurde.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="i_date_start" value="$i_date_start" class="form1"></td></tr>
   <tr><td colspan="2" bgcolor="$style_border" height="5"></tr>
   <tr><td bgcolor="$color_table_headline" colspan="2"><b><i><a name="new"></a>News / Feedback Inhalt</i></b></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>HTML erlauben:</b><br><font size="1">Wenn markiert, sind eingaben von HTML im jeweiligen Bereich zugelassen, sonst werden alle HTML Tags entfernt.</font></td>
     <td bgcolor="$color_table_rest"><input type="checkbox" value="1" name="i_HTML_allow" $checked_i_HTML_allow> News<br><input type="checkbox" value="1" name="i_HTML_allow_fdb" $checked_i_HTML_allow_fdb> Feedback</td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Smilies erlauben:</b><br><font size="1">Wenn markiert, werden diverse Strings zu Smilies konvertiert. Eine List mit den Mglichen Smilies gibt es hier.</font></td>
     <td bgcolor="$color_table_rest"><input type="checkbox" value="1" name="i_smilies_allow" $checked_i_smilies_allow> News<br><input type="checkbox" value="1" name="i_smilies_allow_fdb" $checked_i_smilies_fdb_allow> Feedback</td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Feedback System:</b><br><font size="1">Diverse Optionen f&uuml;r das Feedback System.</font></td>
     <td bgcolor="$color_table_rest"><input type="checkbox" value="1" name="i_disable_fdb" $checked_i_disable_fdb> Kein Feedback<br><input type="checkbox" value="1" name="i_ranking" $checked_i_ranking> Ranking System<br><input type="checkbox" value="1" name="i_disable_ip" $checked_i_disable_ip> IP immer verstecken</td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Ranks:</b><br><font size="1">Wird nur verwendet sofern oben aktiviert. Je mehr Postings ein User macht, desto h&ouml;her wird sein Ranking. Gefolgt von der mindestpostzahl wird der Name mit Leerzeichen angeschlossen. Jede Zeile stellt einen neuen Rang dar.</font></td>
     <td bgcolor="$color_table_rest"><textarea name="rankings" rows="5">$s_rankings</textarea></td></tr>
   <tr><td colspan="2" bgcolor="$style_border" height="5"></tr>
   <tr><td bgcolor="$color_table_headline" colspan="2"><b><i><a name="far"></a>Farben / Design</i></b></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>News Script als SSI:</b><br><font size="1">Ist diese Option aktiviert, kann das Script in shtml Dateien per Include Befehl eingebunden werden.</font></td>
     <td bgcolor="$color_table_rest"><input type="checkbox" value="1" name="SSI" $checked_i_SSI> SSI aktiviert</td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Textfarbe Markierter Bereiche:</b><br><font size="1">Alternative Textfarbe. Wird oft auf Tabellen verwendet.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" value="$style_marked" name="style_marked" class="form1"></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Farbe d. Tabellenkopfzeilen:</b><br><font size="1">Kopfzeilen aller Tabellen, werden mit dieser Hintergrundfarbe best&uuml;ckt.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" value="$color_table_headline" name="color_table_headline" class="form1"></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Farbe Tabellenrest:</b><br><font size="1">Alle restlichen Tabellenzellen werden mit dieser Farbe best&uuml;ckt.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" value="$color_table_rest" name="color_table_rest" class="form1"></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Farbe Tabellenrahmen:</b><br><font size="1">Der Rahmen aller Tabellen [border] hat diese Farbe.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" value="$color_table_border" name="color_table_border" class="form1"></td></tr>
   <tr><td colspan="2" bgcolor="$style_border" height="5"></tr>
   <tr><td bgcolor="$color_table_headline" colspan="2"><b><i><a name="smi"></a>Smilies und Makros</i></b></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Smilies:</b><br><font size="1">Verf&uuml;gbare Smilies. Alle Bilddateien m&uuml;ssen sich in dem Verzeichnis befinden, welches weiter oben als Smilie - Verzeichnis definiert wurde. Die Eingabe Maske [string|dateiname] muss eingehalten werden!!!</font></td>
     <td bgcolor="$color_table_rest"><textarea name="smilies" rows="10" wrap="OFF" class="form1">$s_smilies</textarea></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Makros:</b><br><font size="1">Verf&uuml;gbare Makros. Die Eingabe Maske [makro|html_code] muss eingehalten werden! Makros k&ouml;nnen auch benutzt werden, wenn HTML deaktiviert ist!</font></td>
     <td bgcolor="$color_table_rest"><textarea name="makros" rows="10" wrap="OFF" class="form1">$s_makros</textarea></td></tr>
   </table><br>  
   <table width="80%" border="1" cellspacing="0" cellpadding="4" bordercolor="$color_table_border">
   <tr><td bgcolor="$color_table_headline" colspan="2"><b><i><a name="htm"></a>Allgemeines HTML Design</i></b></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>HTML Kopf:</b><br><font size="1">Der HTML Kopf aller vom Script generierten Seiten. Am Ende darf kein &lt;/head&gt; - Tag stehen! Das Design kann hier angepasst werden.</font></td>
     <td bgcolor="$color_table_rest"><textarea name="html_head" cols="60" rows="10" wrap="OFF" class="form1">$html_head</textarea></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>HTML Body:</b><br><font size="1">Der HTML K&ouml;rper aller vom Script generierten Seiten. Hier kann die Schriftfarbe, Hintergrundfarbe, Linkfarbe, etc. angepasst werden. Achtung: Das &lt;/head&gt; Tag nicht lo&uml;schen!!</font></td>
     <td bgcolor="$color_table_rest"><textarea name="html_body" cols="60" rows="5" wrap="OFF" class="form1">$html_body</textarea></td></tr>
   <tr><td colspan="2" bgcolor="$style_border" height="5"></tr>
   <tr><td bgcolor="$color_table_headline" colspan="2"><b><i>Design der News und des Feedback</i></b></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>HTML Kopf d. News:</b><br><font size="1">In den News, im Feedback, im Archiv, sowie beim Suchen, kann ein Kopf eingeblendet werden. Dieser kann hier bearbeitet werden.</font></td>
     <td bgcolor="$color_table_rest"><textarea name="html_news_headline" cols="60" rows="7" wrap="OFF" class="form1">$html_news_headline</textarea></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>HTML Fuss d. News:</b><br><font size="1">In den News, im Feedback, im Archiv, sowie beim Suchen, kann ein Fuss eingeblendet werden. Dieser kann hier bearbeitet werden.</font></td>
     <td bgcolor="$color_table_rest"><textarea name="html_news_footline" cols="60" rows="7" wrap="OFF" class="form1">$html_news_footline</textarea></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>News Tabelle:</b><br><font size="1">Alle Newseintr&auml;ge werden auf der Page mit diesem HTML Code angezeigt. Im Prinzip kann man einfach den Quelltext eines bestehenden News Eintrages hier rein kopieren. Folgende K&uuml;rzel werden dann durch die jeweilige Funktion ersetzt.<br>
       <b>%mday</b> - Tag d. Monats<br>
       <b>%mon</b> - Monat<br>
       <b>%year</b> - Jahreszahl (4 Stellig)<br>
       <b>%hour</b> - Stunde (24h Format)<br>
       <b>%min</b> - Minute<br>
       <b>%title</b> - Titel d. News<br>
       <b>%content</b> - Die eigentlichen News (Inahlt)<br>
       <b>%name</b> - Author (Name mit eMail Link)<br>
       <b>%feedback</b> - Feedbacklink fr den Newseintrag</font></td>
     <td bgcolor="$color_table_rest"><textarea name="html_table_news" cols="60" rows="15" wrap="OFF" class="form1">$html_table_news</textarea></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Feedback Tabelle:</b><br><font size="1">Alle Feedbackeintr&auml;ge werden auf der Page mit diesem HTML Code angezeigt. Folgende K&uuml;rzel werden dann durch die jeweilige Funktion ersetzt.<br>
       <b>%mday</b> - Tag d. Monats<br>
       <b>%mon</b> - Monat<br>
       <b>%year</b> - Jahreszahl (4 Stellig)<br>
       <b>%hour</b> - Stunde (24h Format)<br>
       <b>%min</b> - Minute<br>
       <b>%name</b> - Author (Name mit eMail Link)<br>
       <b>%registered</b> - Das Ranking d. Users, bzw 'unregistered'<br>
       <b>%regdate</b> - Das Registrierdatum d. Users<br>
       <b>%posts</b> - Anzahl d. Posts<br>
       <b>%ip</b> - IP Adresse, bzw. 'hidden'<br>
       <b>%content</b> - Inhalt d. Feedbacks<br>
       <b>%sigline</b> - Trennlinie fr die Signature<br>
       <b>%signature</b> - Die Signature<br>
       <b>%email</b> - Die eMail Adresse d. Users<br>
       <b>%website</b> - Website d. Users<br>
       <b>%icq</b> - ICQ UIN d. Users</font></td>
     <td bgcolor="$color_table_rest"><textarea name="html_table_feedback" cols="60" rows="15" wrap="OFF" class="form1">$html_table_feedback</textarea></td></tr>
   </table>
   <input type="hidden" name="action" value="setconfig">
   <input type="hidden" name="passwd" value="$f_passwd">
   <table width="80%" border="0" cellpadding="4" cellspacing="0">
    <tr><td><input type="submit" value="&nbsp;Ab&auml;ndern&nbsp;" class="form2">&nbsp;<input type="reset" name="&nbsp;Wiederrufen&nbsp;" class="form2"></td></tr>
   </table>
  </form>
 </div>
 <div align="center"><br>
  <table width="80%" border="1" bordercolor="$color_table_border" cellpadding="4" cellspacing="0">
   <tr><td bgcolor="$color_table_headline"><b><i>Copyright:</i></b></td></tr>
   <tr><td bgcolor="$color_table_rest">
    Copyright (C) 2000 [MV]DarkViper - Thomas Pajor<br>
    ALLE RECHTE VORBEHALTEN<br><br>
    Das Skript ist kostenlos, sofern es privat genutzt wird.<br>
    Bei gewerblicher Nutzung, bitte ich um R&uuml;cksprache (<a href="webmaster\@mvclan.de">webmaster\@mvclan.de</a>).<br>
    &Auml;nderungen an dem Skript sind untersagt!<br>
    Das w&ouml;rtliche &Uuml;bernehmen von ganzen Passagen ist nicht erlaubt.<br>
    Die Urheber- / Copyrightangaben sowie sonstige Links des Urhebers d&uuml;rfen weder entfernt, ver&auml;ndert, noch unleserlich gemacht werden!
   </td></tr>
  </table>
 </div>
 $html_foot
EOF
}


##############################################################################
#
# getconfig: abrufen der konfiguration :)
#
##############################################################################
sub getconfig
{
 open(CFG, "<$file_cfg") || die error(no_file_cfg); @CONFIG = <CFG>; close(CFG);
 $s_setup_passwd = $CONFIG[0]; chomp($s_setup_passwd);
 $url_script = $CONFIG[1]; chomp($url_script);
 $path_news = $CONFIG[2]; chomp($path_news);
 $file_pwd = $CONFIG[3]; chomp($file_pwd);
 $path_sendmail = $CONFIG[4]; chomp($path_sendmail);
 $email_admin = $CONFIG[5]; chomp($email_admin);
 $i_timezone = $CONFIG[6]; chomp($i_timezone);
 $i_show_max = $CONFIG[7]; chomp($i_show_max);
 $i_date_start = $CONFIG[8]; chomp($i_date_start);
 $i_HTML_allow = $CONFIG[9]; chomp($i_HTML_allow);
 $style_marked = $CONFIG[10]; chomp($style_marked); $style_marked_b = "<font color=\"$style_marked\">"; $style_marked_e = "</font>";
 $color_table_headline = $CONFIG[11]; chomp($color_table_headline);
 $color_table_rest = $CONFIG[12]; chomp($color_table_rest);
 $color_table_border = $CONFIG[13]; chomp($color_table_border);
 
 $html_head = $CONFIG[14]; chomp($html_head); $html_head =~ s/{{{\|\|\|}}}/\n/g;
 $html_body = $CONFIG[15]; chomp($html_body); $html_body =~ s/{{{\|\|\|}}}/\n/g;
 $html_foot = $CONFIG[16]; chomp($html_foot); $html_foot =~ s/{{{\|\|\|}}}/\n/g;
 $html_news_headline = $CONFIG[17]; chomp($html_news_headline); $html_news_headline =~ s/{{{\|\|\|}}}/\n/g;
 $html_news_footline = $CONFIG[18]; chomp($html_news_footline); $html_news_footline =~ s/{{{\|\|\|}}}/\n/g;
 $html_table_news = $CONFIG[19]; chomp($html_table_news); $html_table_news =~ s/{{{\|\|\|}}}/\n/g;
 
 $i_HTML_allow_fdb = $CONFIG[20]; chomp($i_HTML_allow_fdb);
 $i_smilies_allow = $CONFIG[21]; chomp($i_smilies_allow);
 $i_smilies_allow_fdb = $CONFIG[22]; chomp($i_smilies_allow_fdb);
 $i_disable_fdb = $CONFIG[23]; chomp($i_disable_fdb);
 $i_ranking = $CONFIG[24]; chomp($i_ranking);
 $s_rankings = $CONFIG[25]; chomp($s_rankings); $s_rankings =~ s/{{{\|\|\|}}}/\n/g;
 $i_disable_ip = $CONFIG[26]; chomp($i_disable_ip);
 $url_smilies = $CONFIG[27]; chomp($url_smilies);
 $i_SSI = $CONFIG[28]; chomp($i_SSI);
 $html_table_feedback = $CONFIG[29]; chomp($html_table_feedback); $html_table_feedback =~ s/{{{\|\|\|}}}/\n/g;
 $s_smilies = $CONFIG[30]; chomp($s_smilies); $s_smilies =~ s/{{{\|\|\|}}}/\n/g;
 $s_makros = $CONFIG[31]; chomp($s_makros); $s_makros =~ s/{{{\|\|\|}}}/\n/g;
 
 # Build Smiley Hash
 @SMILIES = split(/\n/, $s_smilies);
 foreach $entry (@SMILIES) {
   chomp($entry); ($makro, $substitute) = split(/\|/, $entry);
  $hash_smilies{"$makro"} = $substitute;
 }
 # Build Makro Hash
 @MAKROS = split(/\n/, $s_makros);
 foreach $entry (@MAKROS) {
   chomp($entry); ($makro, $substitute) = split(/\|/, $entry);
  $hash_makro{"$makro"} = $substitute;
 }
}


##############################################################################
#
# setconfig: speichern der konfiguration
#
##############################################################################
sub setconfig
{
 loginsetup();
 $f_setup_passwd = $req->param('setup_passwd');
 $f_url_script = $req->param('url_script');
 $f_path_news = $req->param('path_news');
 $f_file_pwd = $req->param('file_pwd');
 $f_path_sendmail = $req->param('path_sendmail');
 $f_email_admin = $req->param('email_admin');
 $f_i_timezone = $req->param('i_timezone');
 $f_i_show_max = $req->param('i_show_max');
 $f_i_date_start = $req->param('i_date_start');
 if ($req->param('i_HTML_allow')) { $f_i_HTML_allow = 1; } else { $f_i_HTML_allow = 0; }
 $f_style_marked = $req->param('style_marked');
 $f_color_table_headline = $req->param('color_table_headline');
 $f_color_table_rest = $req->param('color_table_rest'); 
 $f_color_table_border = $req->param('color_table_border');
 
 $f_html_head = $req->param('html_head'); $f_html_head =~ s/\n/{{{\|\|\|}}}/g;
 $f_html_body = $req->param('html_body'); $f_html_body =~ s/\n/{{{\|\|\|}}}/g;
 $f_html_foot = $html_foot; $f_html_foot =~ s/\n/{{{\|\|\|}}}/g;
 $f_html_news_headline = $req->param('html_news_headline'); $f_html_news_headline =~ s/\n/{{{\|\|\|}}}/g;
 $f_html_news_footline = $req->param('html_news_footline'); $f_html_news_footline =~ s/\n/{{{\|\|\|}}}/g;
 $f_html_table_news = $req->param('html_table_news'); $f_html_table_news =~ s/\n/{{{\|\|\|}}}/g;
 
 if ($req->param('i_HTML_allow_fdb')) { $f_i_HTML_allow_fdb = 1; } else { $f_i_HTML_allow_fdb = 0; }
 if ($req->param('i_smilies_allow')) { $f_i_smilies_allow = 1; } else { $f_i_smilies_allow = 0; }
 if ($req->param('i_smilies_allow_fdb')) { $f_i_smilies_allow_fdb = 1; } else { $f_i_smilies_allow_fdb = 0; }
 
 if ($req->param('i_disable_fdb')) { $f_i_disable_fdb = 1; } else { $f_i_disable_fdb = 0; }
 if ($req->param('i_ranking')) { $f_i_ranking = 1; } else { $f_i_ranking = 0; }
 $f_s_rankings = $req->param('rankings'); $f_s_rankings =~ s/\n/{{{\|\|\|}}}/g;
 if ($req->param('i_disable_ip')) { $f_i_disable_ip = 1; } else { $f_i_disable_ip = 0; }
 $f_url_smilies = $req->param('url_smilies');
 if ($req->param('SSI')) { $f_i_SSI = 1; } else { $f_i_SSI = 0; }
 $f_html_table_feedback = $req->param('html_table_feedback'); $f_html_table_feedback =~ s/\n/{{{\|\|\|}}}/g;

 $f_smilies = $req->param('smilies'); $f_smilies =~ s/\n/{{{\|\|\|}}}/g;
 $f_makros = $req->param('makros'); $f_makros =~ s/\n/{{{\|\|\|}}}/g;
 
 open(CFG, ">$file_cfg") || die error(no_file_cfg);
 print CFG "$f_setup_passwd\n";
 print CFG "$f_url_script\n";
 print CFG "$f_path_news\n";
 print CFG "$f_file_pwd\n";
 print CFG "$f_path_sendmail\n";
 print CFG "$f_email_admin\n";
 print CFG "$f_i_timezone\n";
 print CFG "$f_i_show_max\n";
 print CFG "$f_i_date_start\n";
 print CFG "$f_i_HTML_allow\n";
 print CFG "$f_style_marked\n";
 print CFG "$f_color_table_headline\n";
 print CFG "$f_color_table_rest\n";
 print CFG "$f_color_table_border\n";
 
 print CFG "$f_html_head\n";
 print CFG "$f_html_body\n";
 print CFG "$f_html_foot\n";
 print CFG "$f_html_news_headline\n";
 print CFG "$f_html_news_footline\n";
 print CFG "$f_html_table_news\n";
 
 print CFG "$f_i_HTML_allow_fdb\n";
 print CFG "$f_i_smilies_allow\n";
 print CFG "$f_i_smilies_allow_fdb\n";
 print CFG "$f_i_disable_fdb\n";
 print CFG "$f_i_ranking\n";
 print CFG "$f_s_rankings\n";
 print CFG "$f_i_disable_ip\n";
 print CFG "$f_url_smilies\n";
 print CFG "$f_i_SSI\n";
 print CFG "$f_html_table_feedback\n";
 print CFG "$f_smilies\n";
 print CFG "$f_makros\n";
 close(CFG);

 redirection("Die Einstellungen werden ge&auml;ndert.", "setup&passwd=$f_setup_passwd"); 
 exit;
}


##############################################################################
#
# addprofile: Registrieren eines Feedback benutzers
#
##############################################################################
sub addprofile
{
 if ($i_HTML_allow_fdb) { $html_allow = 'Aktiviert'; } else { $html_allow = 'Deaktiviert'; }
 if ($i_smilies_allow_fdb) { $smilies_allow = 'Aktiviert'; } else { $smilies_allow = 'Deaktiviert'; }
 HTTPHead();
 print <<EOF;
 $html_head
 $html_body
 <h1>Benutzer Registrieren</h1>
 <p align="left">Alle Felder mssen vollstndig ausgefllt werden.</p>
 <div align="center">
 <form method="POST" action="$url_script">
  <input type=hidden name="action" value="postprofile">
  <table width="80%" border="1" bordercolor="$color_table_border" cellpadding="4" cellspacing="0">
    <tr><td bgcolor="$color_table_headline"><b><i>Beschreibung</i></b></td><td bgcolor="$color_table_headline"><b><i>Einstellung</i></b></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Nickname:</b><br><font size="1">Dein Nickname, unter dem Du dich registrieren willst. F&uuml;r diesen Namen wird k&uuml;nftig das Passwort ben&ouml;tigt.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="usrname" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>eMail Adresse:</b><br><font size="1">Deine eMail Adresse.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="usremail" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>Webpage:</b><br><font size="1">Falls Du eine Homepage / Clanpage haben solltest, kannst Du diese hier angeben. Das "http://" ist zwingend notwendig, und darf nicht weggelassen werden.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="usrwww" value="http://" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>ICQ UIN:</b><br><font size="1">Falls Du einen ICQ Account hast, kannst Du hier die Nummer eintragen.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="usricq" class="form1"></td></tr>   
   <tr><td colspan="2" height="5"></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Passwort:</b><br><font size="1">Dein Passwort. Bitte gebt dieses auf keinen Fall an Dritte weiter.</font></td>
     <td bgcolor="$color_table_rest"><input type="password" name="usrpasswd" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>Passwort Best&auml;tigung:</b><br><font size="1">Das Passwort muss hier als Best&auml;tigung wiederholt eingegeben werden.</font></td>
     <td bgcolor="$color_table_rest"><input type="password" name="usrpasswd2" class="form1"></td></tr>   
   <tr><td colspan="2" height="5"></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Signatur:</b><br><font size="1">Hier kann eine Signatur eingegeben werden, die bei jedem Posting angezeigt wird.<br><br>HTML Code ist: <i>$html_allow</i><br><a href=# onClick="javascript:ipwindow = open('$url_script?action=showsmilies','prewindow','scrollbars=yes,toolbar=no,height=480,width=320');">Smilies</a> sind: <i>$smilies_allow</i></font></td>
     <td bgcolor="$color_table_rest"><textarea name="usrsignature" rows="5" cols="30"></textarea></td></tr>   
  </table>
  <table width="80%" border="0" cellpadding="4" cellspacing="0">
    <tr><td><input type="submit" value="&nbsp;Anmelden&nbsp;" class="form2">&nbsp;<input type="reset" name="&nbsp;Wiederrufen&nbsp;" class="form2"></td></tr>
  </table>
 </form>
 </div>
 $html_foot
EOF
 exit;
}


##############################################################################
#
# postprofile: Posten eines Profiles
#
##############################################################################
sub postprofile
{
 # berprfen, ob die wichtigsten Felder eingegeben wurden
 unless($f_usrname && $f_usremail && $f_usrpasswd && $f_usrpasswd2) { die error(form); }
 if (($f_usrname =~ /$gl_sep/) || ($f_usremail =~ /$gl_sep/)) { die error(char); }
 unless($f_usrsignature) { $f_usrsignature = '%none%'; }
 unless($f_usrwww) { $f_usrwww = '%none%'; }
 unless($f_usricq) { $f_usricq = '%none%'; }
 
 # OK, berprfen, ob der User schon existiert.
 open(REG, "<$path_news/$file_reg") || die error(no_file_reg); @REG = <REG>; close(REG);
 foreach $line (@REG) {
  chomp($line); ($s_usrname, $s_usremail, $s_usrwww, $s_usricq, $s_usrpasswd, $s_usrsignature) = split(/$gl_sep_3/, $line);
  if ($s_usrname eq $f_usrname) { die error(usr_exists); }
 }
 
 # Passworts checken
 unless ($f_usrpasswd eq $f_usrpasswd2) { die error(nq_passwd); }
 
 # Cookie Setzen :)
 $i_setfdbpasscook = 1;
 $f_login = $f_usrname;
 $f_passwd = $f_usrpasswd;
 
 # Now Add! *g*
 $f_usrsignature =~ s/\n/<br>/g;
 $f_usrsignature =~ s/$gl_sep/\//g;
 $i_reg_time = time;
 $line = "$f_usrname$gl_sep_3$f_usremail$gl_sep_3$f_usrwww$gl_sep_3$f_usricq$gl_sep_3$f_usrpasswd$gl_sep_3$f_usrsignature$gl_sep_3$gl_null$gl_sep_3$gl_none$gl_sep_3$i_reg_time";
 open(REG, ">>$path_news/$file_reg") || die error(no_file_reg); print REG "$line\n"; close(REG);
 
 redirection("$f_usrname erfolgreich hinzugef&uuml;gt.");
 exit;
}


##############################################################################
#
# editprofile: Editieren eines Benutzers
#
##############################################################################
sub editprofile
{
 loginprofile();
 open(REG, "<$path_news/$file_reg") || die error(no_file_pwd); my @REG = <REG>; close(REG);  
 foreach $line (@REG) {
  chomp($line); ($s_usrname, $s_usremail, $s_usrwww, $s_usricq, $s_usrpasswd, $s_usrsignature, $s_usrposts, $s_usrspecial, $i_reg_time) = split(/$gl_sep_3/, $line);
   if ($f_login eq $s_usrname) { last; }
 }
 
 $s_usrsignature =~ s/<br>/\n/g;
 $s_usrwww =~ s/%none%//g;
 $s_usricq =~ s/%none%//g;
 $s_usrsignature =~ s/%none%//g;
 if ($i_HTML_allow_fdb) { $html_allow = 'Aktiviert'; } else { $html_allow = 'Deaktiviert'; }
 if ($i_smilies_allow_fdb) { $smilies_allow = 'Aktiviert'; } else { $smilies_allow = 'Deaktiviert'; }
  
 HTTPHead();
 print <<EOF;
 $html_head
 $html_body
 <h1>Benutzer Editieren</h1>
 <p align="left">Alle Felder mssen vollstndig ausgefllt werden.</p>
 <div align="center">
 <form method="POST" action="$url_script">
  <input type=hidden name="login" value="$f_login">
  <input type=hidden name="passwd" value="$f_passwd">
  <input type=hidden name="usrposts" value="$s_usrposts">
  <input type=hidden name="usrspecial" value="$s_usrspecial">
  <input type=hidden name="action" value="changeprofile">
  <table width="80%" border="1" bordercolor="$color_table_border" cellpadding="4" cellspacing="0">
    <tr><td bgcolor="$color_table_headline"><b><i>Beschreibung</i></b></td><td bgcolor="$color_table_headline"><b><i>Einstellung</i></b></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Nickname:</b><br><font size="1">Dein Nickname, unter dem Du dich registrieren willst. F&uuml;r diesen Namen wird k&uuml;nftig das Passwort ben&ouml;tigt.</font></td>
     <td bgcolor="$color_table_rest">$s_usrname<input type="hidden" name="usrname" value="$s_usrname"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>eMail Adresse:</b><br><font size="1">Deine eMail Adresse.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="usremail" value="$s_usremail" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>Webpage:</b><br><font size="1">Falls Du eine Homepage / Clanpage haben solltest, kannst Du diese hier angeben. Das "http://" ist zwingend notwendig, und darf nicht weggelassen werden.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="usrwww" value="$s_usrwww" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>ICQ UIN:</b><br><font size="1">Falls Du einen ICQ Account hast, kannst Du hier die Nummer eintragen.</font></td>
     <td bgcolor="$color_table_rest"><input type="text" name="usricq" value="$s_usricq" class="form1"></td></tr>   
   <tr><td colspan="2" height="5"></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Passwort:</b><br><font size="1">Dein Passwort. Bitte gebt dieses auf keinen Fall an Dritte weiter.</font></td>
     <td bgcolor="$color_table_rest"><input type="password" name="usrpasswd" value="$s_usrpasswd" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>Passwort Best&auml;tigung:</b><br><font size="1">Das Passwort muss hier als Best&auml;tigung wiederholt eingegeben werden.</font></td>
     <td bgcolor="$color_table_rest"><input type="password" name="usrpasswd2" value="$s_usrpasswd" class="form1"></td></tr>   
   <tr><td colspan="2" height="5"></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Signatur:</b><br><font size="1">Hier kann eine Signatur eingegeben werden, die bei jedem Posting angezeigt wird.<br><br>HTML Code ist: <i>$html_allow</i><br><a href=# onClick="javascript:ipwindow = open('$url_script?action=showsmilies','prewindow','scrollbars=yes,toolbar=no,height=480,width=320');">Smilies</a> sind: <i>$smilies_allow</i></font></td>
     <td bgcolor="$color_table_rest"><textarea name="usrsignature" rows="5" cols="30">$s_usrsignature</textarea></td></tr>   
  </table>
  <table width="80%" border="0" cellpadding="4" cellspacing="0">
    <tr><td><input type="submit" value="&nbsp;Ab&auml;ndern&nbsp;" class="form2">&nbsp;<input type="reset" name="&nbsp;Wiederrufen&nbsp;" class="form2"></td></tr>
  </table>
 </form>
 </div>
 $html_foot
EOF
 exit;
}


##############################################################################
#
# changeprofile: abndern eines profiles
#
##############################################################################
sub changeprofile
{
 if ($req->param('logintype') eq 'admin') { check_login(); } else { loginprofile(); }
 # berprfen, ob die wichtigsten Felder eingegeben wurden
 unless($f_usrname && $f_usremail && $f_usrpasswd && $f_usrpasswd2) { die error(form); }
 if (($f_usrname =~ /$gl_sep/) || ($f_usremail =~ /$gl_sep/)) { die error(char); }
 unless($f_usrsignature) { $f_usrsignature = '%none%'; }
 unless($f_usrwww) { $f_usrwww = '%none%'; }
 unless($f_usricq) { $f_usricq = '%none%'; }
 unless($f_usrposts) { $f_usrposts = '0'; }
 unless($f_usrspecial) { $f_usrspecial = 'none'; }
 unless ($f_usrpasswd eq $f_usrpasswd2) { die error(nq_passwd); }
 $f_usrsignature =~ s/\n/<br>/g;
 $f_usrsignature =~ s/$gl_sep/\//g;
  
 # Cookie Setzen :)
 unless ($req->param('logintype') eq 'admin') { $i_setfdbpasscook = 1;
  $f_login = $f_usrname;
  $f_passwd = $f_usrpasswd;
 }
 
 open(REG, "<$path_news/$file_reg") || die error(no_file_pwd); my @REG = <REG>; close(REG);  
 open(REG, ">$path_news/$file_reg") || die error(no_file_pwd);
 foreach $line (@REG) {
  chomp($line); ($s_usrname, $s_usremail, $s_usrwww, $s_usricq, $s_usrpasswd, $s_usrsignature, $s_usrposts, $s_usrspecial, $i_reg_time) = split(/$gl_sep_3/, $line);
   unless ($f_usrname eq $s_usrname) { print REG "$line\n"; } else {
    if ($req->param('logintype') eq 'admin') { $f_usrname = $req->param('newusrname'); }
    print REG "$f_usrname$gl_sep_3$f_usremail$gl_sep_3$f_usrwww$gl_sep_3$f_usricq$gl_sep_3$f_usrpasswd$gl_sep_3$f_usrsignature$gl_sep_3$f_usrposts$gl_sep_3$f_usrspecial$gl_sep_3$i_reg_time\n";
   }
 }
 close(REG);
 
 if ($req->param('logintype') eq 'admin') { redirection("$f_usrname erfolgreich abge&auml;ndert.", "adminprofiles&login=$f_login&passwd=$f_passwd"); } else {
  redirection("$f_usrname erfolgreich abge&auml;ndert."); }
 exit;
}


##############################################################################
#
# getpasswd: Passwort ermitteln!
#
##############################################################################
sub getpasswd
{
 HTTPHead();
 print <<EOF;
 $html_head
 $html_body
 <h1>Passwort vergessen. lol</h1>
 <div align="center">
  <form method="POST" action="$url_script">
   <input type=hidden name="action" value="submitpasswd">
   <table width="80%" border="1" bordercolor="$color_table_border" cellpadding="4" cellspacing="0">
     <tr><td bgcolor="$color_table_headline"><b>Nickname:</b><br><font size="1">Dein Nickname. Das Passwort wird dann an die eMail Adresse geschickt, die bei der Registration angegeben wurde.</font></td>
      <td bgcolor="$color_table_rest"><input type="text" name="usrname" value="$s_usrname"></td></tr>   
   </table>
   <table width="80%" border="0" cellpadding="4" cellspacing="0">
     <tr><td><input type="submit" value="&nbsp;Zusenden&nbsp;" class="form2">&nbsp;<input type="reset" name="&nbsp;Wiederrufen&nbsp;" class="form2"></td></tr>
   </table>
  </form> 
 </div>
 $html_foot
EOF
}


##############################################################################
#
# submitpasswd: Finally send passwd *g*
#
##############################################################################
sub submitpasswd
{
# HTTPHead();
 open(REG, "<$path_news/$file_reg") || die error(no_file_pwd); my @REG = <REG>; close(REG);  
 foreach $line (@REG) {
  chomp($line); ($s_usrname, $s_usremail, $s_usrwww, $s_usricq, $s_usrpasswd, $s_usrsignature, $s_usrposts, $s_usrspecial, $i_reg_time) = split(/$gl_sep_3/, $line);
   if ($f_usrname eq $s_usrname) {
    open (SENDMAIL, "| $path_sendmail -t");
    print SENDMAIL "To: User <$s_usremail>\n";
    print SENDMAIL "From: News Script <$email_admin>\n";
    print SENDMAIL "Subject: Zugangsdaten zum Newsscript\n\n";
    print SENDMAIL <<EOF;
Hi $s_usrname,

Hier sind nochmals die Zugangsdaten fuer das News Script auf $ENV{'SERVER_NAME'}:

Username: $s_usrname
Passwort: $s_usrpasswd

Viel Spass weiterhin mit dem Account.
--------------------------------
News - Script by: [MV]DarkViper
eMail: webmaster\@mvclan.de
Webpage: www.mvclan.de
EOF
  close (SENDMAIL);
  redirection("Das Passwort wurde an $s_usremail abgeschickt");
   exit;
   }
 }
 
 die error(usr_no_exists);
 exit;
}


##############################################################################
#
# adminprofiles: Benutzerprofile Administrieren
#
##############################################################################
sub adminprofiles
{
 # Login checken!
 check_login(); 
 open(REG, "<$path_news/$file_reg") || die error(no_file_pwd); my @REG = <REG>; close(REG);
 $i_num_entries = $#REG + 1;
 
 HTTPHead();
 print <<EOF;
  $html_head
  $html_nav
  <div align="center"><b>Eintr&auml;ge insgesamt: $style_marked_b$i_num_entries$style_marked_e</b><br>&nbsp;</div>
  <div align="center">
   <table width="90%" border="1" cellspacing="0" cellpadding="4" bordercolor="$color_table_border">
    <tr bgcolor="$color_table_headline">
     <td><b><i>Benutzer</i></b></td>
     <td><b><i>eMail</i></b></td>
     <td><b><i>Posts</i></b></td>
     <td><b><i>Optionen</i></b></td>
    </tr>
EOF

# Zeilen ausgeben
 foreach $line (@REG) {
  chomp($line); ($s_usrname, $s_usremail, $s_usrwww, $s_usricq, $s_usrpasswd, $s_usrsignature, $s_usrposts, $s_usrspecial, $i_reg_time) = split(/$gl_sep_3/, $line);
  print <<EOF;
    <tr bgcolor="$color_table_rest">
     <td>$s_usrname</td>
     <td><a href="mailto:$s_usremail">$s_usremail</a></td>
     <td>$s_usrposts</td>
     <td><a href="$url_script?action=adminprofileedit&usrname=$s_usrname&login=$f_login&passwd=$f_passwd">edit</a>, <a href="$url_script?action=adminprofiledel&usrname=$s_usrname&login=$f_login&passwd=$f_passwd">delete</a></td>
    </tr>
EOF
 }
 
print <<EOF;
   </table>
  </div>
  $html_foot
EOF
 
 exit;
}


##############################################################################
#
# adminprofileedit: editieren eines profiles (admin version)
#
##############################################################################
sub adminprofileedit
{
 check_login();
 unless ($f_admin == 1) { die error(perm_denied); }
 unless($f_usrname) { die error(no_param); }
 open(REG, "<$path_news/$file_reg") || die error(no_file_pwd); my @REG = <REG>; close(REG);  
 foreach $line (@REG) {
  chomp($line); ($s_usrname, $s_usremail, $s_usrwww, $s_usricq, $s_usrpasswd, $s_usrsignature, $s_usrposts, $s_usrspecial, $i_reg_time) = split(/$gl_sep_3/, $line);
   if ($f_usrname eq $s_usrname) { last; }
 }
 
 $s_usrsignature =~ s/<br>/\n/g;
 $s_usrwww =~ s/%none%//g;
 $s_usricq =~ s/%none%//g;
 $s_usrsignature =~ s/%none%//g;
 if ($i_HTML_allow_fdb) { $html_allow = 'Aktiviert'; } else { $html_allow = 'Deaktiviert'; }
 if ($i_smilies_allow_fdb) { $smilies_allow = 'Aktiviert'; } else { $smilies_allow = 'Deaktiviert'; }
  
 HTTPHead();
 print <<EOF;
 $html_head
 $html_nav
 <div align="center">
 <form method="POST" action="$url_script">
  <input type=hidden name="action" value="changeprofile">
  <input type=hidden name="login" value="$f_login">
  <input type=hidden name="passwd" value="$f_passwd">
  <input type=hidden name="logintype" value="admin">
  <table border="1" bordercolor="$color_table_border" cellpadding="4" cellspacing="0">
    <tr><td bgcolor="$color_table_headline"><b><i>Beschreibung</i></b></td><td bgcolor="$color_table_headline"><b><i>Einstellung</i></b></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Nickname:</b></td>
     <td bgcolor="$color_table_rest"><input type="text" name="newusrname" value="$s_usrname"><input type="hidden" name="usrname" value="$s_usrname"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>eMail Adresse:</b></td>
     <td bgcolor="$color_table_rest"><input type="text" name="usremail" value="$s_usremail" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>Webpage:</b></td>
     <td bgcolor="$color_table_rest"><input type="text" name="usrwww" value="$s_usrwww" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>ICQ UIN:</b></td>
     <td bgcolor="$color_table_rest"><input type="text" name="usricq" value="$s_usricq" class="form1"></td></tr>   
   <tr><td colspan="2" height="5"></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Passwort:</b><br></td>
     <td bgcolor="$color_table_rest"><input type="password" name="usrpasswd" value="$s_usrpasswd" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>Passwort Best&auml;tigung:</b></td>
     <td bgcolor="$color_table_rest"><input type="password" name="usrpasswd2" value="$s_usrpasswd" class="form1"></td></tr>   
   <tr><td colspan="2" height="5"></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Signatur:</b><br></td>
     <td bgcolor="$color_table_rest"><textarea name="usrsignature" rows="5" cols="30">$s_usrsignature</textarea></td></tr>   
   <tr><td colspan="2" height="5"></td></tr>
    <tr><td bgcolor="$color_table_headline"><b>Spezial Rang:</b><br></td>
     <td bgcolor="$color_table_rest"><input type="text" name="usrspecial" value="$s_usrspecial" class="form1"></td></tr>   
    <tr><td bgcolor="$color_table_headline"><b>Anzahl Posts:</b><br></td>
     <td bgcolor="$color_table_rest"><input type="text" name="usrposts" value="$s_usrposts" class="form1"></td></tr>   
  </table>
  <table border="0" cellpadding="4" cellspacing="0">
    <tr><td><div align="center"><input type="submit" value="&nbsp;Ab&auml;ndern&nbsp;" class="form2">&nbsp;<input type="reset" name="&nbsp;Wiederrufen&nbsp;" class="form2"></div></td></tr>
  </table>
 </form>
 </div>
 $html_foot
EOF
 exit;
}


##############################################################################
#
# adminprofiledel: lschen eines profiles (admin version)
#
##############################################################################
sub adminprofiledel
{
 check_login();
 unless ($f_admin == 1) { die error(perm_denied); }
 unless($f_usrname) { die error(no_param); }
 open(REG, "<$path_news/$file_reg") || die error(no_file_pwd); my @REG = <REG>; close(REG);  
 open(REG, ">$path_news/$file_reg") || die error(no_file_pwd);
 foreach $line (@REG) {
  chomp($line); ($s_usrname, $s_usremail, $s_usrwww, $s_usricq, $s_usrpasswd, $s_usrsignature, $s_usrposts, $s_usrspecial, $i_reg_time) = split(/$gl_sep_3/, $line);
   unless ($f_usrname eq $s_usrname) { print REG "$line\n"; }
 }
 close(REG);
 
 redirection("Profil $f_usrname erfolgreich gel&ouml;scht.", "adminprofiles&login=$f_login&passwd=$f_passwd");
 exit;
}


##############################################################################
#
# showsmilies: Anzeigen aller Smilies :)
#
##############################################################################
sub showsmilies
{
 HTTPHead();
 print <<EOF;
 $html_head
 $html_body
 <div align="center"><h1>Smilies</h1></div>
 <p align="left"><font size="1">
  Smilies (Emoticons) sind kurze Strings, die Emotionen ausdr&uuml;cken. Sofern der Webmaster zul&auml;sst, besteht mit diesem Script die M&ouml;glichkeit diese Zeichenketten durch Grafiken zu ersetzen. Folgende Strings werden ersetzt:
 </font></p>
 <div align="center">
  <table border="1" bordercolor="$color_table_border" cellpadding="4" cellspacing="0">
   <tr><td bgcolor="$color_table_headline"><b><i>Zeichenkette</i></b></td><td bgcolor="$color_table_headline"><b><i>Emoticon Bild</i></b></td></tr>
EOF
 while (($makro, $substitute) = each %hash_smilies) {
  print <<EOF;
   <tr><td bgcolor="$color_table_rest">$makro</td>
     <td bgcolor="$color_table_rest"><img src="$url_smilies/$substitute"></td></tr>   
EOF
 }
 print <<EOF;
  </table>
 </div>
 <p align="center"><h2>
  Vielen Dank an den <a href="http://www.t2d.de" target="_blank">=|T2D|= Clan</a> f&uuml;r die Bereitstellung einiger Smilies.
 </h2></p>
 $html_foot
EOF
 exit;
}


##############################################################################
#
# showmakros: Anzeigen aller Makros :)
#
##############################################################################
sub showmakros
{
 HTTPHead();
 print <<EOF;
 $html_head
 $html_body
 <div align="center"><h1>Makros</h1></div>
 <p align="left"><font size="1">
  Makros erlauben es, ohne Kenntnisse in HTML, kleine Design&auml;nderungen, wie beispielsweise fette Schrift, auf einfachem Wege einzubinden. Dazu muss nur eines der unteren Strings eingegeben werden, und das Script konvertiert es automatisch in den richtigen HTML Code.
  Fr weitere Details &uuml;ber die Makros kontaktiert bitte den <a href="mailto:$email_admin">Webmaster</a>
 </font></p>
 <div align="center">
  <table border="1" bordercolor="$color_table_border" cellpadding="4" cellspacing="0">
   <tr><td bgcolor="$color_table_headline"><b><i>Zeichenkette</i></b></td><td bgcolor="$color_table_headline"><b><i>HTML Code</i></b></td></tr>
EOF
 while (($makro, $substitute) = each %hash_makro) {
  $substitute =~ s/\"/&quot;/g;
  $substitute =~ s/\</&lt;/g;
  $substitute =~ s/\>/&gt;/g;
  print <<EOF;
   <tr><td bgcolor="$color_table_rest">$makro</td>
     <td bgcolor="$color_table_rest">$substitute</td></tr>   
EOF
 }
 print <<EOF;
  </table>
 </div>
 $html_foot
EOF
 exit;
}


##############################################################################
#
# loginprofile: Einloggen fr ein Profile
#
##############################################################################
sub loginprofile
{
  # berprfen ob Login - Infos mit bertragen wurde. (Wenn nicht, zur Eingabe auffordern)
  unless ($f_login || $f_passwd)
  {
 HTTPHead();
    print <<EOF;
    $html_head
    $html_body
    <div align="center"><h1>Bitte Einloggen</h1></div>
     <form method=post action="$url_script"><input type=hidden name="action" value="$f_action">
      <div align="center">
       <table border="1" cellspacing="0" cellpadding="4" bordercolor="$color_table_border">
        <tr><td bgcolor="$color_table_headline"><b><i>Username:</i></b></td><td bgcolor="$color_table_rest"><input type=text name="login" value="$f_login_fdb_ck" class="form1"></td></tr>
        <tr><td bgcolor="$color_table_headline"><b><i>Passwort:</i></b></td><td bgcolor="$color_table_rest"><input type=password name="passwd" value="$f_passwd_fdb_ck" class="form1"></td></tr>
        <tr><td bgcolor="$color_table_rest" colspan="2"><div align="center"><input type=submit value="&nbsp;Einloggen&nbsp;" class="form2"> <input type=reset value="Zur&uuml;cksetzen" class="form2"></div></td></tr>
       </table>
      </div>
     </form>
    $html_foot
EOF
    exit;
  }
  
  # OK, anscheinend wurden infos submittet... Let's check for PWD!
  # Auslesen der Datenbank
  open(REG, "<$path_news/$file_reg") || die error(no_file_pwd); my @REG = <REG>; close(REG);
  
  # Suchen des Benutzereintrags!
  foreach $line (@REG) {
   chomp($line); ($s_usrname, $s_usremail, $s_usrwww, $s_usricq, $s_usrpasswd, $s_usrsignature, $s_usrposts, $s_usrspecial, $i_reg_time) = split(/$gl_sep_3/, $line);
    if (($f_passwd eq $s_usrpasswd) && ($f_login eq $s_usrname)) { $i_setfdbpasscook = 1; return; } # berprfung der PWDs & Benutzernamen
  }
  
  die error(bad_reg_login); # :((((
}


##############################################################################
#
# nohtml: Remove any HTML:
#
##############################################################################
sub nohtml
{
 $input = $_[0];
 $input =~ s/<br>/__br__/g;
 $input =~ s/<([^>]|\n)*>//g;
 $input =~ s/__br__/<br>/g;
 return ($input);
}


##############################################################################
#
# addsmilies: Repleace staff by smilies
#
##############################################################################
sub addsmilies
{
 $input = $_[0];
 while (($makro, $substitute) = each %hash_smilies) {
   $smiley = "<img src=\"$url_smilies/$substitute\">"; 
   $input =~ s/\Q$makro\E/$smiley/g;
 }
 return($input); 
}


##############################################################################
#
# incposts: Erhhen der Anzahl der Posts
#
##############################################################################
sub incposts
{
 $input = $_[0];
 open(REG, "<$path_news/$file_reg") || die error(no_file_pwd); my @REG = <REG>; close(REG);  
 open(REG, ">$path_news/$file_reg") || die error(no_file_pwd);
 foreach $line (@REG) {
  chomp($line); ($s_usrname, $s_usremail, $s_usrwww, $s_usricq, $s_usrpasswd, $s_usrsignature, $s_usrposts, $s_usrspecial, $i_reg_time) = split(/$gl_sep_3/, $line);
   unless ($input eq $s_usrname) { print REG "$line\n"; } else {
    $s_usrposts++;
    print REG "$s_usrname$gl_sep_3$s_usremail$gl_sep_3$s_usrwww$gl_sep_3$s_usricq$gl_sep_3$s_usrpasswd$gl_sep_3$s_usrsignature$gl_sep_3$s_usrposts$gl_sep_3$s_usrspecial$gl_sep_3$i_reg_time\n";
   }
 }
 close(REG);
}


##############################################################################
#
# loginsetup: Einloggen fr das Setup
#
##############################################################################
sub loginsetup
{
  # berprfen ob Login - Infos mit bertragen wurde. (Wenn nicht, zur Eingabe auffordern)
  unless ($f_passwd)
  {
 HTTPHead();
    print <<EOF;
    $html_head
    $html_body
    <div align="center"><h1>Bitte Passwort eingeben</h1></div>
     <form method=post action="$url_script"><input type=hidden name="action" value="$f_action">
      <div align="center">
       <table border="1" cellspacing="0" cellpadding="4" bordercolor="$color_table_border">
        <tr><td bgcolor="$color_table_headline"><b><i>Passwort:</i></b></td><td bgcolor="$color_table_rest"><input type=password name="passwd" class="form1"></td></tr>
        <tr><td bgcolor="$color_table_rest" colspan="2"><div align="left"><input type=submit value="&nbsp;Einloggen&nbsp;" class="form2"> <input type=reset value="Zur&uuml;cksetzen" class="form2"></div></td></tr>
       </table>
      </div>
     </form>
    $html_foot
EOF
    exit;
  }
  
  if ($f_passwd eq $s_setup_passwd) { return; }
  die error(bad_reg_login); # :((((
}